{ File:         Alarm.pas }
{ Created:      Mon Sep 09 00:25:28 1991 }
{ Description:  Main routines for "Alarm" Windows application }

{{ STARTBLOCK   File Version Information   (REGENERATE) }
{ Regenerated:  Mon Sep 09 00:25:28 1991 }
{ Skeleton by:  Winpro/3, a product from Louis J. Cutrona, Jr. }
{               tpw.skl version 0.05 }
{{ ENDBLOCK }

program AlarmProgram ;

{$R Alarm.res }

uses
  WinDos,
  WinTypes,
  WinProcs,
  Strings,
  WObjects,
  StdWnds,
  AlarRC, AlarGbl, AlarDlg ;


{  A L A R M   }
{  A P P L I C A T I O N  O B J E C T  D E F I N I T I O N  }

type
  tAlarm = object( TApplication )
    constructor Init( lpszName: PChar ) ;
    procedure   InitInstance ; virtual ;
    procedure   InitMainWindow ; virtual ;
    procedure   Run ; virtual ;
  end ;


{  A L A R M   W I N D O W  }
{  M A I N  W I N D O W  O B J E C T  D E F I N I T I O N  }

type
  tpAlarmWindow = ^tAlarmWindow ;
  tAlarmWindow = object( TWindow )
    constructor Init( pwoParent: PWindowsObject; lpszTitle: PChar ) ;
    destructor  Done ;  Virtual ;

    { We need a new GetWindowClass to have our own icon and menu }
    procedure   GetWindowClass( var WndClass: TWndClass ) ; virtual ;
    { We need to override GetClassName because different Windows }
    { applications must use different class names.               }
    function    GetClassName: PChar ; virtual ;

    { One-time initialization after window is created }
    procedure   SetupWindow; virtual ;

    { We need to handle wm_Timer messages and wm_User messages }
    procedure   WMTimerMethod( var Msg: TMessage ) ;
                virtual wm_First + wm_Timer ;
    procedure   WMUserMethod( var Msg: TMessage ) ;
                virtual wm_First + wm_User ;

    { WM_COMMAND processing methods (menu selections & accelerator keys ) }
    procedure   dlg_SetAlarmTimeMethod( var Msg: TMessage ) ;
                virtual cm_First + dlg_SetAlarmTime ;
    procedure   idmALARMONMethod( var Msg: TMessage ) ;
                virtual cm_First + idmALARMON ;
    procedure   idmALARMOFFMethod( var Msg: TMessage ) ;
                virtual cm_First + idmALARMOFF ;
    procedure   dlg_AboutAlarmMethod( var Msg: TMessage ) ;
                virtual cm_First + dlg_AboutAlarm ;
    procedure   STDCLOSEMethod( var Msg: TMessage ) ;
                virtual cm_First + STDCLOSE ;
    procedure   idmHIDEMethod( var Msg: TMessage ) ;
                virtual cm_First + idmHIDE ;
  end ;



{ A L A R M   W I N D O W . I N I T }
{{ STARTBLOCK Main window constructor (REGENERATE) }

constructor tAlarmWindow.Init( pwoParent: PWindowsObject; lpszTitle: PChar ) ;
begin
  TWindow.Init( pwoParent, lpszTitle ) ;
  Attr.Style := ws_Overlapped
    or ws_Caption
    or ws_SysMenu
    or ws_MinimizeBox
    or ws_ClipSiblings
    (*or ws_Visible*) ;
  Attr.X := 140 ;
  Attr.Y := 150 ;
  Attr.W := 385 ;
  Attr.H := 160 ;
end ;

{{ ENDBLOCK }

{ A L A R M   W I N D O W . D O N E }
{ Main window destructor }

destructor tAlarmWindow.Done ;
begin
  { Do here any cleanup required when the main window closes }
  if gbl_cAlarmSet = 'Y' then
    KillTimer( hWindow, 1 ) ;
  { Then, call standard cleanup }
  TWindow.Done ;
end ;


{ A L A R M   W I N D O W .  G E T  W I N D O W  C L A S S }
{ Modify default window object characteristics }

procedure tAlarmWindow.GetWindowClass( var WndClass: TWndClass ) ;
begin
  { Let TWindow set the defaults }
  TWindow.GetWindowClass( WndClass ) ;

  {{ STARTBLOCK Override TWindow window class defaults (REGENERATE) }
  WndClass.hIcon         := LoadIcon( hInstance, PChar( ALARM_ICON ) ) ;
  WndClass.lpszMenuName  := PChar( ALARM_MENU ) ;
  WndClass.hbrBackground := color_Window + 1 ;
  {{ ENDBLOCK }
end ;

{ A L A R M   W I N D O W .  G E T  C L A S S  N A M E }

function tAlarmWindow.GetClassName: PChar;
begin
  GetClassName := 'Alarm' ;
end;

{ Correct execution of the SetupWindow procedure defined below requires }
{ short-circuit boolean evaluation.  Although this is the default, it   }
{ may have been overridden through settings in the Options|Compiler     }
{ menu.  The next line turns short-circuit evaluation on as insurance.  }
{$B-}

procedure tAlarmWindow.SetupWindow;
var
  bCancel: Bool ;
  hmenuPopup: HMenu ;
  p: PChar ;
begin
  if gbl_cAlarmSet = 'Y' then
  begin
    { We want a timer.  See if one is available.  If not, give user }
    { the option of cancelling or retrying after shutting down      }
    { something else that uses a timer.                             }
    bCancel := False ;
    while not bCancel and not Bool( SetTimer( hWindow, 1, 30000, nil ) ) do
      if idCancel = MessageBox( hWindow,
        'Sorry, no more clocks or timers available.',
        'Alarm Can''t Run',
        mb_RetryCancel or mb_IconExclamation ) then
        bCancel := True ;
    if bCancel then
      CloseWindow ;

    { We got a timer, so check the 'On' menu item and uncheck 'Off' }
    hmenuPopup := GetSubMenu( GetMenu( hWindow ), 0 ) ;
    CheckMenuItem( hmenuPopup, idmALARMON, mf_ByCommand or mf_Checked ) ;
    CheckMenuItem( hmenuPopup, idmALARMOFF, mf_ByCommand or mf_Unchecked ) ;
  end;
  { See if the user specified /s -s /S or -S on the command line and }
  { if so, leave the window visible.                                 }
  if  ( StrPos( CmdLine, '/s' ) = nil )
  and ( StrPos( CmdLine, '-s' ) = nil )
  and ( StrPos( CmdLine, '/S' ) = nil )
  and ( StrPos( CmdLine, '-S' ) = nil ) then
    CmdShow := sw_Hide ;
end;


procedure tAlarmWindow.WMTimerMethod( var Msg: TMessage ) ;
var
  wDayOfWeek: Word ;
  wSecond: Word ;
  wSec100: Word ;
begin
  GetDate( gbl_wYearNow, gbl_wMonthNow, gbl_wDayNow, wDayOfWeek ) ;
  gbl_wMonthNow := gbl_wMonthNow - 1900 ;
  GetTime( gbl_wHourNow, gbl_wMinuteNow, wSecond, wSec100 ) ;
  if   ( gbl_wYearNow   < gbl_wYearAlarm   )
    or ( gbl_wMonthNow  < gbl_wMonthAlarm  )
    or ( gbl_wDayNow    < gbl_wDayAlarm    )
    or ( gbl_wHourNow   < gbl_wHourAlarm   )
    or ( gbl_wMinuteNow < gbl_wMinuteAlarm ) then
  begin
    { Too early.  Wait a minute }
    SetTimer( hWindow, 1, 30000, nil ) ;
  end
  else
  begin
    { Now! }
    KillTimer( hWindow, 1 ) ;
    gbl_cAlarmSet := 'N' ;
    SendMessage( hWindow, wm_Command, idmALARMOFF, 0 ) ;
    MessageBeep( 0 ) ;
    MessageBox( hWindow,
      dlg_SetAlarmTimeTransferBuf.szEM_MESSAGE,
      'Ding-a-Ling',
      mb_OK or mb_IconAsterisk ) ;
  end ;
end ;

procedure tAlarmWindow.WMUserMethod( var Msg: TMessage ) ;
begin
  { If window is hidden, make it visible.  Otherwise, ignore }
  MessageBeep( 0 ) ;
  if not IsWindowVisible( hWindow ) then
  begin
    Show( sw_ShowNormal ) ;
    BringWindowToTop( hWindow ) ;
  end ;
end ;



{ AlarmWindow -- WM_COMMAND processing methods }
{ (menu selections & accelerator keys ) }

{{ STARTBLOCK Main window menu/accelerator selection dlg_SetAlarmTime (REGENERATE) }
procedure tAlarmWindow.dlg_SetAlarmTimeMethod( var Msg: TMessage ) ;
var
  RetCode: Integer ;
  pdlg_SetAlarmTimeDialog: tpdlg_SetAlarmTimeDialog ;
  szBuf: Array[0..11] of Char ;
  i: Integer ;
begin
  pdlg_SetAlarmTimeDialog := New( tpdlg_SetAlarmTimeDialog, Init( @Self, PChar( dlg_SetAlarmTime ) ) ) ;
  RetCode := Application^.ExecDialog( pdlg_SetAlarmTimeDialog ) ;
  if RetCode = id_OK then
  begin
    { User selected OK pushbutton or equivalent. }
    { Updated dialog data are in dlg_SetAlarmTimeTransferBuf. }
    { Translate into numbers }
    with dlg_SetAlarmTimeTransferBuf do
    begin
      { In a more fully developed example, each of these values }
      { would be error-checked.                                 }
      Val( PChar( @szET_YEAR[0] ), gbl_wYearAlarm, RetCode ) ;
      Str( gbl_wYearAlarm:2, szET_YEAR  ) ;
      Val( PChar( @szET_MONTH[0] ), gbl_wMonthAlarm, RetCode ) ;
      Str( gbl_wMonthAlarm:2, szET_MONTH  ) ;
      Val( PChar( @szET_DAY[0] ), gbl_wDayAlarm, RetCode ) ;
      Str( gbl_wDayAlarm:2, szET_DAY  ) ;
      Val( PChar( @szET_HOUR[0] ), gbl_wHourAlarm, RetCode ) ;
      Str( gbl_wHourAlarm:2, szET_HOUR  ) ;
      Val( PChar( @szET_MINUTE[0] ), gbl_wMinuteAlarm, RetCode ) ;
      Str( gbl_wMinuteAlarm:2, szET_MINUTE  ) ;

      StrCopy( szBuf, szET_YEAR    ) ;
      StrCat(  szBuf, szET_MONTH   ) ;
      StrCat(  szBuf, szET_DAY     ) ;
      StrCat(  szBuf, szET_HOUR    ) ;
      StrCat(  szBuf, szET_MINUTE  ) ;

      { Replace blanks with zeros }
      for i := 0 to 9 do
        if szBuf[i] = ' ' then szBuf[i] := '0' ;

      szBuf[10] := gbl_cAlarmSet ;
      szBuf[11] := Chr(0) ;

      { Record current settings in WIN.INI }
      WriteProfileString( 'Alarm', 'Time', szBuf ) ;
      WriteProfileString( 'Alarm', 'Msg', szEM_MESSAGE ) ;

    end ;
  end ;
end ;
{{ ENDBLOCK }

{{ STARTBLOCK Main window menu/accelerator selection idmALARMON (PRESERVE) }
procedure tAlarmWindow.idmALARMONMethod( var Msg: TMessage ) ;
var
  hmenuPopup: HMenu ;
  RetCode: Integer ;
  bCancel: Bool ;
  szBuf: Array[0..11] of Char ;
begin
  { If alarm is already on, nothing to do }
  { If alarm is off, turn it on and move the menu check mark }
  hmenuPopup := GetSubMenu( GetMenu( hWindow ), 0 ) ;
  if Bool( mf_Unchecked ) = CheckMenuItem( hmenuPopup, idmALARMON,
    mf_ByCommand or mf_Checked ) then
  begin
    { The alarm was off.  "On" is now checked.  Uncheck "Off" }
    CheckMenuItem( hmenuPopup, idmALARMOFF, mf_ByCommand or mf_Unchecked ) ;

    { We want a timer.  See if one is available.  If not, give user }
    { the option of cancelling or retrying after shutting down some }
    { other application that consumes timers.                       }
    bCancel := False ;
    while not bCancel and not Bool( SetTimer( hWindow, 1, 30000, nil ) ) do
      if idCancel = MessageBox( hWindow,
        'Sorry, no more clocks or timers available.',
        'Alarm Can''t Be Turned On',
        mb_RetryCancel or mb_IconExclamation ) then
      begin
    	CheckMenuItem( hmenuPopup, idmALARMON, mf_ByCommand or mf_Unchecked ) ;
    	CheckMenuItem( hmenuPopup, idmALARMOFF, mf_ByCommand or mf_Checked ) ;
        bCancel := True ;
      end ;
    if bCancel then
      CloseWindow ;

    { Record the new state internally and in WIN.INI }
    GetProfileString( 'Alarm', 'Time', gbl_pszDefault,
      szBuf, SizeOf( szBuf ) ) ;
    szBuf[10] := 'Y' ;
    gbl_cAlarmSet := 'Y' ;
    WriteProfileString( 'Alarm', 'Time', szBuf ) ;
  end ;
end ;
{{ ENDBLOCK }

{{ STARTBLOCK Main window menu/accelerator selection idmALARMOFF (PRESERVE) }
procedure tAlarmWindow.idmALARMOFFMethod( var Msg: TMessage ) ;
var
  hmenuPopup: HMenu ;
  RetCode: Integer ;
  szBuf: Array[0..11] of Char ;
begin
  { If alarm is already off, nothing to do }
  { If alarm is on, turn it off and move the menu check mark }
  hmenuPopup := GetSubMenu( GetMenu( hWindow ), 0 ) ;
  if Bool( mf_Unchecked ) = CheckMenuItem( hmenuPopup, idmALARMOFF,
    mf_ByCommand or mf_Checked ) then
  begin
    { The alarm was on.  "Off" is now checked.  Uncheck "On" }
    CheckMenuItem( hmenuPopup, idmALARMON, mf_ByCommand or mf_Unchecked ) ;

    { Record the change in WIN.INI }
    GetProfileString( 'Alarm', 'Time', gbl_pszDefault,
      szBuf, SizeOf( szBuf ) ) ;
    szBuf[10] := 'N' ;
    WriteProfileString( 'Alarm', 'Time', szBuf ) ;

    { Alarm might have already been turned off because it went off }
    if gbl_cAlarmSet = 'Y' then
    begin
      KillTimer( hWindow, 1 ) ;
      gbl_cAlarmSet := 'N' ;
    end ;
  end ;
end ;
{{ ENDBLOCK }

{{ STARTBLOCK Main window menu/accelerator selection dlg_AboutAlarm (REGENERATE) }
procedure tAlarmWindow.dlg_AboutAlarmMethod( var Msg: TMessage ) ;
var
  RetCode: Integer ;
  pdlg_AboutAlarmDialog: tpdlg_AboutAlarmDialog ;
begin
  pdlg_AboutAlarmDialog := New( tpdlg_AboutAlarmDialog, Init( @Self, PChar( dlg_AboutAlarm ) ) ) ;
  RetCode := Application^.ExecDialog( pdlg_AboutAlarmDialog ) ;
  if RetCode = id_OK then
  begin
    { User selected OK pushbutton or equivalent. }
    { Updated dialog data are in dlg_AboutAlarmTransferBuf. }
  end
  else
    if RetCode = id_Cancel then
    begin
      { User selected Cancel pushbutton or equivalent }
      { or dialog could not be executed at all.       }
      { Dialog data in dlg_AboutAlarmTransferBuf are unchanged. }
    end ;
end ;
{{ ENDBLOCK }

{{ STARTBLOCK Main window menu/accelerator selection STDCLOSE (REGENERATE) }
procedure tAlarmWindow.STDCLOSEMethod( var Msg: TMessage ) ;
var
  RetCode: Integer ;
begin
   { User wants to terminate application }
   CloseWindow ;
end ;
{{ ENDBLOCK }

{{ STARTBLOCK Main window menu/accelerator selection idmHIDE (PRESERVE) }
procedure tAlarmWindow.idmHIDEMethod( var Msg: TMessage ) ;
begin
   Show( sw_Hide ) ;   { Hide the window }
end ;
{{ ENDBLOCK }



{ A L A R M  . I N I T }
{ Application constructor }

constructor tAlarm.Init( lpszName: PChar ) ;
begin
  TApplication.Init( lpszName ) ;
end ;

{ A L A R M   --  Main window initialization }

procedure tAlarm.InitMainWindow ;
begin
   MainWindow := New( tpAlarmWindow, Init( nil,
      gbl_pRsrcStrings^.psz( IDS_MAINWINDOWCAPTION ) ) ) ;
end ;


{ A L A R M   --  Instance initialization }

procedure tAlarm.InitInstance ;
var
  hwndPrevInst: HWnd ;
  szBuf: Array[0..11] of Char ;
  RetCode: Integer ;
begin
  { See if another instance exists.  This is the definitive method }
  hwndPrevInst
    := FindWindow( 'Alarm', nil ) ;
  if hwndPrevInst <> 0 then
  begin
    { Tell the previous instance to show itself if not already showing }
    PostMessage( hwndPrevInst, wm_User, 0, 0 ) ;
    { Don't bother to continue }
    Status := 2 ;  { Non-zero status will abort TApplication.Run }
  end ;

  if Status = 0 then
  begin
    GetProfileString( 'Alarm', 'Time', gbl_pszDefault,
      szBuf, SizeOf( szBuf ) ) ;
    gbl_cAlarmSet := szBuf[10] ;

    with dlg_SetAlarmTimeTransferBuf do
    begin
      szBuf[10] := Chr(0) ;
      StrCopy( szET_MINUTE, @szBuf[8] ) ;
      Val( PChar( @szET_MINUTE[0] ), gbl_wMinuteAlarm, RetCode ) ;
      szBuf[8] := Chr(0) ;
      StrCopy( szET_HOUR,   @szBuf[6] ) ;
      Val( PChar( @szET_HOUR[0] ), gbl_wHourAlarm, RetCode ) ;
      szBuf[6] := Chr(0) ;
      StrCopy( szET_DAY,    @szBuf[4] ) ;
      Val( PChar( @szET_DAY[0] ), gbl_wDayAlarm, RetCode ) ;
      szBuf[4] := Chr(0) ;
      StrCopy( szET_MONTH,  @szBuf[2] ) ;
      Val( PChar( @szET_MONTH[0] ), gbl_wMonthAlarm, RetCode ) ;
      szBuf[2] := Chr(0) ;
      StrCopy( szET_YEAR,   @szBuf[0] ) ;
      Val( PChar( @szET_YEAR[0] ), gbl_wYearAlarm, RetCode ) ;
      GetProfileString( 'Alarm', 'Msg', '',
        szEM_MESSAGE, SizeOf( szEM_MESSAGE ) ) ;
    end ;
  end;

  if Status = 0 then
  begin
    gbl_pRsrcStrings^.Preload( hInstance ) ;
    if gbl_pRsrcStrings^.hStrings = 0 then
    begin
      { Predefined error numbers work down from $FFFF, so we work up from 1 }
      Status := 1 ;  { Non-zero status will abort TApplication.Run }
    end ;
  end ;

  { Do the standard instance initialization stuff }
  if Status = 0 then
    TApplication.InitInstance ;
end ;

{ A L A R M  -  Override Run method to avoid error message when we      }
{ intentionally don't want to continue because another instance exists. }

procedure tAlarm.Run ;
begin
  { If we want to quietly cancel this instance, Status is 2 } 
  if Status <> 2 then
    TApplication.Run ;
end ;


var
  AlarmApplication: tAlarm ;

begin
  AlarmApplication.Init( 'Alarm' ) ;
  AlarmApplication.Run ;
  AlarmApplication.Done ;
end.


{   E N D   O F   F I L E   Alarm.pas   }
