' AliasCom.Bas
' Module to contain the AliasCom package of routines
'

' $INCLUDE: 'ALIASCOM.BI'

DIM SHARED OldCOMLo%(0 TO 3), OldCOMHi%(0 TO 3)

SUB ACInitialize

' This subprogram gets the current set of serial port addresses
' from the BIOS data area and saved them in both the OldCOMVals%()
' array, and the AliasCom module's local versions.

DEF SEG = &H40			' address the BIOS data segment
OldCOMHi%(COM1%) = PEEK(1)	' get COM1 port high byte
OldCOMLo%(COM1%) = PEEK(0)	' get COM1 port low byte
' form COM1 port address
OldCOMVals%(COM1%) = OldCOMHi%(COM1%) * 256 OR OldCOMLo%(COM1%)

OldCOMHi%(COM2%) = PEEK(3)	' get COM2 port high byte
OldCOMLo%(COM2%) = PEEK(2)	' get COM2 port low byte
' form COM2 port address
OldCOMVals%(COM2%) = OldCOMHi%(COM2%) * 256 OR OldCOMLo%(COM2%)

OldCOMHi%(COM3%) = PEEK(5)	' get COM3 port high byte
OldCOMLo%(COM3%) = PEEK(4)	' get COM3 port low byte
' form COM3 port address
OldCOMVals%(COM3%) = OldCOMHi%(COM3%) * 256 OR OldCOMLo%(COM3%)

OldCOMHi%(COM4%) = PEEK(7)	' get COM4 port high byte
OldCOMLo%(COM4%) = PEEK(6)	' get COM4 port low byte
' form COM4 port address
OldCOMVals%(COM4%) = OldCOMHi%(COM4%) * 256 OR OldCOMLo%(COM4%)

DEF SEG
END SUB

SUB ACSetPort (PortID%, PortAddr%)

' Subprogram to allow the programmer to set up a port
' that the BIOS did not initialize (usually because the
' BIOS didn't recognize the serial port/fax/modem, etc.).

PortLo% = PortAddr% MOD 256
PortHi% = PortAddr% \ 256

POKE PortID%*2, PortLo%
POKE PortID%*2+1, PortHi%

OldCOMLo%(PortID%) = PortLo%
OldCOMHi%(PortID%) = PortHi%
OldCOMVals%(PortID%) = PortAddr%

END SUB

SUB ACSetAlias (AliasPortID%, UsesPortID%)

' Subprogram to make one COM port an alias for another COM port.

POKE AliasPortID%*2, OldCOMLo%(UsesPortID%)
POKE AliasPortID%*2+1, OldCOMHi%(UsesPortID%)

END SUB

SUB ACRestore

' Subprogram to put the BIOS data area back to "normal".

FOR PortID% = COM1% TO COM4%
   POKE PortID%*2, OldCOMLo%(PortID%)
   POKE PortID%*2+1, OldCOMHi%(PortID%)
NEXT PortID%

END SUB
