'-----------------TYPE Structures------------------------------------------

    TYPE CentralDirRec              'Structure used by the EtZipDirLong routine
        Signature   AS LONG
        CreationOS  AS INTEGER
        ExtractVer  AS INTEGER
        GenPurFlag  AS INTEGER
        Method      AS INTEGER
        FTime       AS INTEGER
        FDate       AS INTEGER
        Crc32       AS LONG
        CompSize    AS LONG
        UnCompSize  AS LONG
        FilNamLen   AS INTEGER
        ExtraFldLen AS INTEGER
        CommentLen  AS INTEGER
        DiskNumStrt AS INTEGER
        IntFilAttr AS INTEGER
        ExtFilAttr AS LONG
        LocalHeader AS LONG
    END TYPE

    TYPE LhaDirRec                  'Used by the EtLhaDirLong routine
        HeaderSize  AS STRING * 1
        CheckSum    AS STRING * 1
        Method      AS STRING * 5
        CompSize    AS LONG
        UnCompSize  AS LONG
        FTime       AS INTEGER
        FDate       AS INTEGER
        FilAttr     AS INTEGER
        FilNamLen   AS STRING * 1
        Crc16       AS INTEGER
    END TYPE

    TYPE ArjDirRec
        Signature   AS STRING * 2   'Used by the EtArjDirLong routine
        HeaderSize  AS INTEGER
        F           AS STRING * 1
        CompressVer AS STRING * 1
        ExtractVer  AS STRING * 1
        CreationOS  AS STRING * 1
        GenPurFlag  AS STRING * 1
        Method      AS STRING * 1
        FileType    AS STRING * 1
        Reserved    AS STRING * 1
        FTime       AS INTEGER
        FDate       AS INTEGER
        CompSize    AS LONG
        UnCompSize  AS LONG
        Crc32       AS LONG
        FilNamStart AS INTEGER
        AccessMode  AS INTEGER
        FutureUse   AS INTEGER
    END TYPE

    TYPE CompInfo                   'Used by EtCPrint routine
        ZipName     AS STRING * 67
        FileName    AS STRING * 67
        Operation   AS INTEGER
        TotalSize   AS LONG
        CurrentByte AS LONG
        CompLen     AS LONG
        CompMethod  AS INTEGER
        Row         AS INTEGER
        Column      AS INTEGER
        CR          AS INTEGER
    END TYPE

'-----------------User-level routines--------------------------------------

DECLARE FUNCTION EtArcType% (Handle%, Status%)

DECLARE FUNCTION EtArjDir% (Handle%, DirName$())
DECLARE FUNCTION EtArjDirLong% (Handle%, DirStuff() AS ANY, DirName$())
DECLARE FUNCTION EtArjCnt% (Handle%, Status%)

DECLARE FUNCTION EtLhaDir% (Handle%, DirName$())
DECLARE FUNCTION EtLhaDirLong% (Handle%, DirStuff() AS ANY, DirName$())
DECLARE FUNCTION EtLhaCnt% (Handle%, Status%)

DECLARE FUNCTION EtZipOpen% (FileName$, Mode%, Handle%)
DECLARE SUB EtZipClose (Handle%)

DECLARE FUNCTION EtViewZip% (ArcFile$, Spec$())

DECLARE FUNCTION EtUnZip% (Handle%, Destination$, Spec$, Switch$)
DECLARE FUNCTION EtZip% (Handle%, Spec$(), Switch$)
DECLARE FUNCTION EtZipComment$ (Handle%, Status%)
DECLARE FUNCTION EtZipNewComment% (Handle%, Comment$)

DECLARE FUNCTION EtZipCnt% (Handle%, Status%)
DECLARE FUNCTION EtZipDir% (Handle%, DirName$())
DECLARE FUNCTION EtZipDirLong% (Handle%, DirStuff() AS ANY, DirName$())
DECLARE FUNCTION EtZipFileInfo%(Handle%, FileName$, FileInfo AS ANY)

DECLARE FUNCTION EtZipMem% (Segment%, Offset%, Length&, ZipHandle%, InternalName$, CompMethod%)
DECLARE FUNCTION EtUnZipMem% (Segment%, Offset%, StartingOffset&, Length&, ZipHandle%, InternalName$)

DECLARE FUNCTION EtZipString% (Source$, ZipHandle%, InternalName$, CompMethod%)
DECLARE FUNCTION EtUnZipString% (Dest$, StartingOffset&, Length&, ZipHandle%, InternalName$)

DECLARE FUNCTION EtArrayAddress%
DECLARE FUNCTION EtZipArray% (ArrayAddr%, ZipHandle%, InternalName$, CompMethod%)
DECLARE FUNCTION EtUnZipArray% (ArrayAddr%, StartingOffset&, Length&, ZipHandle%, InternalName$)

DECLARE FUNCTION EtFileDate$ (Date%)
DECLARE FUNCTION EtFileTime$ (Time%)

DECLARE SUB EtCPrint (Info AS CompInfo, Msg$, Prompt$, Flag%)
DECLARE SUB EtCPrintOff ()
DECLARE SUB EtCPrintOn ()
DECLARE FUNCTION EtCPrintIsOn% ()

'------------------------User Interface Routines------------------------

DECLARE SUB EtCLS ()
DECLARE SUB EtDrawBox (Top%, Left%, Bottom%, Right%, Title$)
DECLARE SUB EtDrawSetColor (Fg%, Bg%, BFg%, BBg%, SelFg%, SelBg%, BoxTyp%)
DECLARE SUB EtDrawInit ()
DECLARE SUB EtGetFileName (Title$, Text$, V%, H%, L%, MustExist%)
DECLARE SUB EtInput (Title$, Text$, V%, H%, L%, Intype%, LegalChar$)
DECLARE SUB EtMessage (Message$, Title$, Save%, WaitKey$, PressedKey%, Delay%, FirstRow%)
DECLARE SUB EtPickBox (Top%, Left%, Bottom%, Right%, Title$, Sel$(), Save%, Selection%)
DECLARE SUB EtPickBoxTag (Top%, Left%, Bottom%, Right%, Title$, Sel$(), Save%, Selection%, Tag%(), UseTags%)
DECLARE SUB EtRestoreScreen (Scr%())
DECLARE SUB EtSaveScreen (Scr%())

