'PROGRAM - CREATEDB.BAS
DEFINT A-Z

'*******************************************************************
'**   Purpose - This program creates two ISAM files with 3 tables **
'**             and 6 indexes in one file and 1 table with 1      **
'**             index in the other file.                          **
'*******************************************************************

'$INCLUDE: 'ISAM.BI'

'Sample customer records

  DATA "COB01","The Cobb Group"
  DATA "MAR01","Markwen International"
  DATA "MAR02","Marrion Hotels"
  DATA "DEN01","Arthur Dent, Inc."
  DATA "99999",""

'Sample invoice header records

  DATA 10121,"COB01","910123",   13424,"MAR02","910213"
  DATA 23852,"DEN01","910506",   10125,"COB01","910231"
  DATA 13242,"XXXXX","910202"
  DATA 99999,"",""

'Sample invoice line item records

  DATA 10121,"B2234",3,0.10    ,10121,"A3325",2,19.25
  DATA 13424,"QEE32",4,4.59    ,23852,"UI898",1,15.65
  DATA 10125,"A3513",6,12.95   ,13242,"23512",2,0.08
  DATA 23852,"XXXXX",3,14.83
  DATA 99999,"",0,0

'Sample inventory records

  DATA "A3513","Hammer",8.35
  DATA "UI898","Lamp",11.22
  DATA "23512","10-32 1/4 in. screw",0.02
  DATA "QEE32","Screwdriver",1.64
  DATA "A3325","+5 Soldering iron",13.13
  DATA "B2234","3/4 in. washer",0.03
  DATA "99999","",0
  
  CLS : PRINT "..ISAM create multiple tables in multiple databases"

'**********************  Create ISAM file  ****************************

  DIM Cust AS CustomerRec          'Dimension records for tables
  DIM IH AS InvoiceHeaderRec
  DIM IL AS InvoiceLineItemRec
  DIM Inven AS InventoryRec

' ============ Create and write records to customer table =============

  OPEN "AR.MDB" FOR ISAM CustomerRec "CustTbl" AS #1
  CREATEINDEX #1, "ByCustNbr", 1, "CustNbr"
  CREATEINDEX #1, "ByCompName", 0, "CompName"
  
  READ Cust.CustNbr, Cust.CompName
  DO
    INSERT #1, Cust
    READ Cust.CustNbr, Cust.CompName
  LOOP UNTIL Cust.CustNbr = "99999"
  CLOSE 1

' ========== Create and write records to invoice header table =========

  OPEN "AR.MDB" FOR ISAM InvoiceHeaderRec "InvHdrTbl" AS #1
  CREATEINDEX #1, "ByCustNbr", 1, "CustNbr", "InvNbr"
  CREATEINDEX #1, "ByDate", 1, "Date", "InvNbr"

  READ IH.InvNbr, IH.CustNbr, IH.Date
  DO
    INSERT #1, IH
    READ IH.InvNbr, IH.CustNbr, IH.Date
  LOOP UNTIL IH.InvNbr = 99999
  CLOSE 1

' ======== Create and write records to invoice line item table ========

  OPEN "AR.MDB" FOR ISAM InvoiceLineItemRec "InvLineItemTbl" AS #1
  CREATEINDEX #1, "ByInvNbr", 1, "InvNbr", "InvenNbr"
  CREATEINDEX #1, "ByInvenNbr", 0, "InvenNbr"

  READ IL.InvNbr, IL.InvenNbr, IL.NbrSold, IL.PriceEach
  DO
    INSERT #1, IL
    READ IL.InvNbr, IL.InvenNbr, IL.NbrSold, IL.PriceEach
  LOOP UNTIL IL.InvNbr = 99999
  CLOSE 1

' =========== Create and write records to inventory table =============

  OPEN "INVEN.MDB" FOR ISAM InventoryRec "InvenTbl" AS #1
  CREATEINDEX #1, "ByInvenNbr", 1, "InvenNbr"

  READ Inven.InvenNbr, Inven.Desc, Inven.UnitCost
  DO
    INSERT #1, Inven
    READ Inven.InvenNbr, Inven.Desc, Inven.UnitCost
  LOOP UNTIL Inven.InvenNbr = "99999"
  CLOSE 1

  END


