
 ' --------------------------------------------------------------------------
 ' DT.BAS  03-19-90 : Requires BC 7.0 and MicroHelp Mach 2 as written.
 ' Redirectable, commented timestamp utility.
 ' --------------------------------------------------------------------------
 '
 ' This program placed into the public domain by the author:  T. E. McCormick
 ' Date and time in english; BASIC with MicroHelp Mach2 rtns.
 ' The MicroHelp rtns ARE NOT reqd to capture the mixed case cmd tail.
 '
 ' Command tail, if any, is prepended as entered (mixed case).
 ' For example: dt Accts Receivable Backup Began:          ... would produce:
 '     Accts Receivable Backup Began: Monday, March 19, 1990.  21:57 o'clock.
 '     This can be redirected into a file as a commented timestamp.
 '
 ' To capture the command tail raw (not forced to upper case), see
 ' CTAILRAW.BAS in BC7CTAIL.ZIP, or pick the code out of this pgm.
 ' You need qbx.bi and the DIM stmt following it, and the two subroutines.
 ' --------------------------------------------------------------------------

 '$INCLUDE: 'QBX.BI'
  DIM REGS AS RegType
	
	CALL MhDay(Year%, Month%, Day%, DayOfWeek%)    ' MicroHelp Mach 2
	DIM WkDay$(7), Mnth$(12)

	    WkDay$(1) = "Sunday"
	    WkDay$(2) = "Monday"
	    WkDay$(3) = "Tuesday"
	    WkDay$(4) = "Wednesday"
	    WkDay$(5) = "Thursday"
	    WkDay$(6) = "Friday"
	    WkDay$(7) = "Saturday"
	   
	    Mnth$(1) = "January"
	    Mnth$(2) = "Februaru"
	    Mnth$(3) = "March"
	    Mnth$(4) = "April"
	    Mnth$(5) = "May"
	    Mnth$(6) = "June"
	    Mnth$(7) = "July"
	    Mnth$(8) = "August"
	    Mnth$(9) = "September"
	    Mnth$(10) = "October"
	    Mnth$(11) = "November"
	    Mnth$(12) = "December"
	
  GOSUB I.CmdTail                    ' Returns mixed case in CmdLine$

	DayOfWeek% = DayOfWeek% + 1        ' because it is relative to 0
	
	Lin$ = CmdLine$ + WkDay$(DayOfWeek%) + ", " + Mnth$(Month%) + STR$(Day%)
	Lin$ = Lin$ + "," + STR$(Year%)
	Lin$ = Lin$ + ".  " + LEFT$(TIME$, 5) + " o'clock." + CHR$(0)

 'MicroHelp	Mach 2 rtn...      Could use normal print stmt.
  CALL MhPrint(Lin$)         ' Uses current colors without automatic crlf

  SYSTEM
 '------


I.CmdTail:
 ' --------------------------------------------------------------------
 ' Next parses command tail in PSP to get it without BASIC`s conversion
 ' of it to upper case, ...which we DO NOT want in this case!  We begin
 ' at PSP + 81 hex  (129 decimal)  as first char of command tail,   and
 ' proceed left to right until encountering the first null char CHR$(0).
 ' The first char of the command tail is usually a space character. This
 ' routine DOES NOT remove it.
 ' PSP + 80 is the length of the command line image.
 ' --------------------------------------------------------------------
   GOSUB I.PSP.Get    ' Get Program Segment Prefix addr to find cmd tail
   DEF SEG = REGS.bx                  ' <---- Take Notice!
   CmdLine$ = ""                      ' Init work field to nothing
   Temp% = PEEK(128) + 128            ' Psp + 80 hex is length incl null
   IF (Temp% < 129) OR (Temp% > 255) THEN Temp% = 129  ' Limit range
   FOR I% = 129 TO Temp%              ' Psp + 81 hex for up to 128 chars
       C$ = CHR$(PEEK(I%))            ' Get one character
       IF C$ = CHR$(0) THEN EXIT FOR  ' Terminating null of cmd tail
	     CmdLine$ = CmdLine$ + C$       ' Add each char to workfield
   NEXT I%
   DEF SEG                            ' Reset setting done above
   RETURN
 '--------------------------------------------------------------------

I.PSP.Get:
 ' --------------------------------------------------------------
 ' Call DOS interrupt 21H: BASIC Program Segment Prefix Address
 ' The command line begins 80h (129) bytes past this address.
 ' * You MUST include qbx.bi BEFORE other code to "call interruptx"!
 ' * You MUST DIM Regs, too.
 ' --------------------------------------------------------------
 ' Set registers for DOS CALL: returns PSP in BX reg.
   REGS.ax% = &H5100
   CALL INTERRUPT(&H21, REGS, REGS)
   RETURN              ' NOTE: Exit with seg pointing to PSP
 ' ------------------------------------------------------------



 '---------- Compile and Link as follows; requires Microhelp Mach 2 ---------
 ' @Echo OFF
 ' Rem CLDT.BAT 03-19-90 BASIC Compile 7.0 & Link DT.BAS with MicroHelp M2.
 ' D:
 ' CD \BC7\BIN

 ' BC DT /O /Ot /FS /LR /FPi /T /C:256;
 '    IF ERRORLEVEL 1 Echo Error occurred during BC.  Skipping Link.
 '    IF ERRORLEVEL 1 GOTO @FINIS

 ' Rem Link MS stub files and three MicroHelp Mach 2 object files...
 ' LINK /EX /NOE DT.OBJ+NOFLTIN+NOEDIT+NOCOM+NOLPT+SMALLERR+mhday+mhprint+mhmmiscpx,,,QBX.LIB;
 '    IF ERRORLEVEL 1 Echo Error occurred during Link.

 ':@FINIS
