'
' EMSKit demo
' Copyright InfoSoft 1989-1991, 1992
' ALL RIGHTS RESERVED
'


' simple program to test and demonstrate the use of EMSKit functions
' as well as their syntactical usage.


DECLARE FUNCTION ArraySize& (lo&, hi&, size%)
' array Size is an Inline function to determine and array size in bytes


' ALL EMSKit routines are functions that must be declared as type INTEGER (%)
DECLARE FUNCTION EMSInstalled%
DECLARE FUNCTION EMSVersion% (maj%, min%)
DECLARE FUNCTION EMSStat%
DECLARE FUNCTION EMSPageAvail% (pages%)
DECLARE FUNCTION EMSPageFree% (pages%)
DECLARE FUNCTION EMSMAlloc% (pages%, Handle%)
DECLARE FUNCTION EMSMRelease% (Handle%)

DECLARE FUNCTION EMSHandleSize% (Handle%, size%)

DECLARE FUNCTION EMSPutArray% (SEG Array AS ANY, ASize&, Handle%)
DECLARE FUNCTION EMSGetArray% (SEG Array AS ANY, ASize&, Handle%)
DECLARE FUNCTION EMSActiveHCnt% (HCnt%)
DECLARE FUNCTION EMSMaxHCnt% (HCnt%)

DECLARE FUNCTION EMSModHandle% (pages%, Handle%)

DECLARE FUNCTION EMSHAttrGet% (Handle%, attr%)
DECLARE FUNCTION EMSHAttrSet% (Handle%, attr%)
DECLARE FUNCTION EMSAttrType% (attr%)
DECLARE FUNCTION EMSBootPrep%

DECLARE FUNCTION EMSHNameGet% (h%, n$)
DECLARE FUNCTION EMSHNameSet% (h%, n$)

DECLARE FUNCTION EMSHSearch% (n$, Handle%)
DECLARE FUNCTION EMSItemFetch% (SEG item AS ANY, place%, size%, EMSHandle%)
DECLARE FUNCTION EMSItemStore% (SEG item AS ANY, place%, size%, EMSHandle%)

DECLARE FUNCTION EMSPHTable% (SEG ptr%)

    ' a fake TYPE for storing user defined arrays to EMS
    TYPE struct
	   x AS STRING * 30
	   y AS INTEGER
    END TYPE



    CLEAR
    DEFINT A-Z

    OPTION BASE 1
    CLS

    REDIM Sarry(512) AS struct          ' Array of type STRUCT
					'  HUGE arrays must be in
					'  powers of 2  and run with '/ah

    REDIM Arry(2000)                    ' standard array


    ' Load user def. array with misc
    FOR x = 1 TO 512
	   Sarry(x).x = STRING$(80, LTRIM$(STR$(x)))
	   Sarry(x).y = x
    NEXT x

    ' store info in std array
    FOR x = 1 TO 2000
	   Arry(x) = x
    NEXT x

    ' get size of array
    PRINT "Size of TYPE array: ";
    PRINT ArraySize&(LBOUND(Sarry), UBOUND(Sarry), 2); "bytes."
    PRINT
    PRINT

    ' Get installation status
    EMSCode = EMSInstalled
    IF EMSCode THEN
	   PRINT "EMS is installed ("; EMSCode; ")"
    ELSE
	   PRINT "No EMS Driver (EMM) found.  Aborting."
	   SYSTEM
    END IF

    ' get hardware/software functionality
    PRINT
    PRINT "EMS status is: ";
    EMSCode = EMSStat
    IF EMSCode THEN
	   PRINT "Something amiss with EMS hardware or driver!  Aborting."
    ELSE
	   PRINT "A-Ok!"
    END IF

    ' get handles in use
    errc = EMSActiveHCnt(Handles)
    PRINT "EMS handles in use (OS uses 1): "; Handles

    ' List handles and size
    PRINT
    PRINT "  Handle         Pg Size           Byte Size"
    PRINT "  ======         =======           ========="
   
    FOR x = 2 TO Handles
	   errc = EMSHandleSize%(x, size%)
	   PRINT "   "; x; "              "; size; "               "; size * 16
    NEXT x


    ' request a handle from EMM for use in demo.  We want 32k.
    PRINT
    PRINT
    PRINT "Allocating a handle of 2 pages (32kb)"
    errc = EMSMAlloc(2, Handle)
    PRINT "EMSAlloc error return: "; errc
    IF errc THEN
	   BEEP
	   PRINT "EMM page allocation error!  Aborting."
	   PRINT "Not enough free EMS memory for demo??"
	   SYSTEM
    END IF

    GOSUB TanyK


    ' we have an array, we have a handle, so we'll show the array,
    ' store it in EMS,  erase it, then restore it from EMS
    ' the PC Mag driver is rather slow on this one too.

    ' show array contents
    PRINT "Selected portions of array as of now:"
    FOR x = 1 TO 2000 STEP 100
	   PRINT Arry(x);
    NEXT x

    PRINT
    PRINT

    ' Put array in EMS
    errc = EMSPutArray%(Arry(1), 4000, Handle%)
    PRINT "Array stored in EMS.  Erasing array.  Contents now:"

    ' erase and show empty array
    REDIM Arry(2000)
    FOR x = 1 TO 2000 STEP 100
	   PRINT Arry(x);
    NEXT x

    PRINT
    PRINT

    ' fetch array from EMA and display part of it
    PRINT "Fetching array from EMS.  Contents now (should match original):"
    errc = EMSGetArray%(Arry(1), 4000, Handle%)

    FOR x = 1 TO 2000 STEP 100
	   PRINT Arry(x);
    NEXT x
    PRINT
    PRINT

    GOSUB TanyK


    ' repeat same thing, but wth user defined (TYPE) array
    PRINT "Selected portions of TYPE array as of now:"
    FOR x = 1 TO 512 STEP 30
	   PRINT Sarry(x).x; Sarry(x).y
    NEXT x

    PRINT
    PRINT
    GOSUB TanyK


    PRINT "Storing array in EMS.  Erasing array.  Contents now:"
    ' will overwrite old data written there!
    ASize& = CLNG(512) * CLNG(32)
    errc = EMSPutArray%(Sarry(1), ASize&, Handle%)

    REDIM Sarry(512) AS struct
    FOR x = 1 TO 512 STEP 30
	   PRINT Sarry(x).x; Sarry(x).y = x
    NEXT x

    PRINT
    PRINT
    GOSUB TanyK

    PRINT "Fetching array from EMS.  Contents now should match original:"
    errc = EMSGetArray%(Sarry(1), ASize&, Handle%)

    FOR x = 1 TO 512 STEP 30
	PRINT Sarry(x).x; Sarry(x).y
    NEXT x

    PRINT
    PRINT

    GOSUB TanyK

    ' we can store non-array items to EMS, albeit clumsily, with
    ' EMSItemStore and EMSITemFetch.

    PRINT "Store a single item to EMS (VERY handy and powerful feature):"

    item = 777                     ' item to store
    place = 100                    ' where to store it
							'  this is saving item to 100*2
							'  as if it were element 100 in an array
							'
     '  This is EXCELLENT for storing a mixture of non related
     '  variables in EMS, and for UPDATING an array you have built,
     '  stored in EMS, and since erased.
     '
    errc = EMSItemStore%(item, place, 2, Handle%)
    PRINT

    IF errc THEN
	   PRINT "There was an error storing item to EMS."
	   PRINT "This is probably minor and has to do with running in the QB"
	   PRINT "environment or using (D)ebug (S)et to alter program flow."
	   PRINT "Exit QB, reboot and rerun demo."
	   PRINT
	   SYSTEM
    ELSE
	   PRINT "Storing the value "; item; " to EMS as if in array position "; place
	   PRINT "(same as storing Array(100) to EMS, or storing a simple variable"
	   PRINT "( as if it were a member of an array at location Array(100) )."
    END IF

    PRINT
    PRINT
    PRINT "Fetching a single item from EMS:"
    fitem = 0
    PRINT "Variable BEFORE fetch: "; fitem
    errc = EMSItemFetch%(fitem, place, 2, Handle%)
    PRINT "Variable AFTER fetch: "; fitem; " should match "; item


    PRINT
    PRINT
    PRINT "Fetching a TYPE item from EMS:"
    errc = EMSItemFetch%(Sarry(1), 200, LEN(Sarry(1)), Handle%)
    PRINT Sarry(1).x; Sarry(1).y
    PRINT
    PRINT "Should Match:"
    PRINT Sarry(200).x; Sarry(200).y


    GOSUB TanyK

    PRINT
    PRINT "EMSKit Handle name functions:"
    PRINT
    PRINT

    ' name to use
    HName$ = "foobarxx"
    PRINT "Setting Handle name to "; HName$
    errc = EMSHNameSet%(Handle%, HName$)
    IF errc THEN
	   PRINT "Error code returned: "; errc
	   IF errc = 159 THEN
		  PRINT "EMM does not suport names."
	   END IF
    END IF

    PRINT
    PRINT

    ' init new variable, to use to fetch name
    j$ = SPACE$(8)
    PRINT "Preparing to fetch name.  New variable =" + CHR$(34) + j$ + CHR$(34)
    errc = EMSHNameGet%(Handle%, j$)
    PRINT "Fetched name: "; j$

    PRINT
    PRINT

    n$ = "FOOBARXX"
    PRINT "Preparing to search for "; n$
    errc = EMSHSearch%(n$, shandle%)
    PRINT "Error code return is: "; errc; " handle is: "; shandle
    IF errc THEN
	   PRINT "Error code indicates that "; n$; " <> "; HName$
    END IF

    PRINT
    PRINT

    n$ = LCASE$(n$)
    PRINT "Now, preparing to search for: "; n$
    errc = EMSHSearch%(n$, shandle%)
    PRINT "Error code return is: "; errc; " handle is: "; shandle

    GOSUB TanyK

    PRINT "Misc EMSKit EMM driver information:"
    PRINT

    ' get type of handle attributes supported
    errc = EMSAttrType%(attr%)
    PRINT "Attribute type: "; attr
    IF attr THEN
	PRINT "Handles CAN be set to survive warm boots!"
    ELSE
	 PRINT "Handles CANNOT be set to survive warm boots!"
	 PRINT
    END IF

    ' get EMM version ID
    errc = EMSVersion(maj, min)
    PRINT USING "EMM Version is ##_.#"; maj; min
    PRINT

    ' get TOTAL (used and unused) EMS memory installed
    errc = EMSPageAvail(cnt)
    PRINT "Maximum EMS pages and bytes supported: "; cnt, cnt * 16
    PRINT

    ' get UNused EMS memory
    errc = EMSPageFree(cnt)
    PRINT "EMS pages/bytes free: "; cnt; cnt * 16
    PRINT
    PRINT

    ' get size of active handle
    errc = EMSHandleSize%(Handle, size%)
    PRINT "Modify open handle:"
    PRINT "Current size: "; size

    IF maj >= 4 THEN
	   PRINT "Modifying to 1 page (16kb):"

	   ' call EMSKit to modify handle to 2 pages
	   errc = EMSModHandle%(1, Handle%)

	   PRINT "Error return (enough memory for new request): "; errc

	   errc = EMSHandleSize%(Handle%, size%)
	   PRINT "Handle page size now: "; size
    ELSE
	   PRINT "This EMM version does support modified handles."
    END IF

    GOSUB TanyK

    PRINT
    PRINT "Releasing memory/handle allocated: "
    errc = EMSMRelease%(Handle)
    PRINT
    PRINT

    errc = EMSHandleSize%(Handle%, size%)
    PRINT "Handle page size now: "; size

    PRINT
    PRINT
    PRINT "Note that not even HALF of all EMSKit fucntions have been shown!"


SYSTEM

TanyK:
    BEEP
    LOCATE 23, 25
    PRINT "Press any key for more"
    x$ = INPUT$(1)
    CLS
RETURN

FUNCTION ArraySize& (lo&, hi&, size%)
    DEFINT A-Z

    '            (End - Begin) +1) * sizeof( int | long | float | double)
    ArraySize& = ((hi& - lo&) + 1) * size


END FUNCTION

