'PROGRAM - ISAMTEST.BAS
DEFINT A-Z

'*******************************************************************
'**   Purpose - This program creates an ISAM file to test adding  **
'**             duplicate records with multifield keys by         **
'**             searching with SEEKEQ before adding a record.     **
'*******************************************************************

  CLS

  PRINT "ISAM test for multi field key lookups"

'*********************  Setup ISAM file  ***************************

  TYPE BusMailList              'Definition for ISAM table
    CustID    AS STRING * 5     'Random key to be indexed
    FirstName AS STRING * 15
    LastName  AS STRING * 15
    Company   AS STRING * 30
    Address   AS STRING * 30
    City      AS STRING * 20
    State     AS STRING * 2
    Zip       AS STRING * 5
  END TYPE

  DIM ML AS BusMailList   'Record variable to move data to/from file

  OPEN "ML.MDB" FOR ISAM BusMailList "BusinessList1" AS #1

' Create multifield index on company, last, and first name fields

  CREATEINDEX #1, "TestMulti", 0, "Company", "LastName", "FirstName"

  SETINDEX #1, "TestMulti"                     'Set the active index

'***********************  Add records to file **********************

'=== Create record portion that we won't change during execution ===

  ML.CustID = "00000"
  ML.Address = "Test address"
  ML.City = "Test city"
  ML.State = "TS"
  ML.Zip = "TZipC"

'================ Insert several records for testing ===============

  ML.Company = "The Cobb Group"
  ML.FirstName = "Blake"
  ML.LastName = "Ragsdell"
  PRINT "Add test record 1"
  INSERT #1, ML

  ML.Company = "The Cobb Group"
  ML.FirstName = "Joe"
  ML.LastName = "Pierce"
  PRINT "Add test record 2"
  INSERT #1, ML

  ML.Company = "Kentucky Fried Chicken"
  ML.FirstName = "Marco"
  ML.LastName = "Mason"
  PRINT "Add test record 3"
  INSERT #1, ML

'======= Now try to insert a record with duplicate information =====

  ML.Company = "The Cobb Group"
  FirstName$ = "Blake"
  LastName$ = "Ragsdell"

' ============ First check to see if the keys exist ================

  SEEKEQ #1, ML.Company, LastName$, FirstName$

  IF EOF(1) THEN                           'Key not found-> Insert
    ML.FirstName = FirstName$
    ML.LastName = LastName$
    INSERT #1, ML
    PRINT "Inserted new record"
  ELSE                                     'Duplicate key found
    PRINT "Duplicate key found"
    PRINT "Record not inserted"
  END IF

  CLOSE 1
  KILL "ML.MDB"
  END
