'============================================================================
'
'                      LDEMO1.BAS - LITE Window Demo #1
'                         ProWindows(tm) LITE 4.00
'              (c) Copyright 1988-1991 DSE Software Publishing
'
'==========================================================================
'
'    To make use of this demonstration program, you must load BASIC
'    EXATCLY as follows:
'
'         QB LDEMO1 /AH /L LITEDEMO               (for QuickBASIC)
'         QBX LDEMO1 /AH /EA /L LITEDEMO          (for BASIC PDS 7)
'
'==========================================================================

REM $DYNAMIC

' =======================================================================
' These constants should be defined in ALL applications, whether or not
' they are actually used.  If a particular module will not be used, define
' the appropraite as '0'.
' =======================================================================

CONST WINMEMSIZE% = 8191           ' Window memory, used by 'VirMem%()'
CONST SCRNMEMSIZE% = 4096          ' Screen storage memory, used by 'scrn%()'
CONST MAXWINDOWS% = 30             ' Maximum number of windows

' =======================================================================
' INCLUDE modules should follow
' =======================================================================

REM $INCLUDE: 'lite.bi'

CLEAR , , 4096                     ' Set aside additional stack space

' =======================================================================
' Be sure to DIM your variables
' =======================================================================

DIM SHARED VirMem(WINMEMSIZE) AS INTEGER
DIM SHARED scrn(SCRNMEMSIZE) AS INTEGER
DIM SHARED vcb(MAXWINDOWS) AS vircb
DIM SHARED wcb(MAXWINDOWS) AS wincb
DIM SHARED wcbndx(MAXWINDOWS) AS INTEGER

' =======================================================================
' Program initialization code
' =======================================================================

	ReCycleMode 1                           ' enable "Video Recycling" saves 24K

	InitPro                                 ' initialize ProWindows

	MouseInstalled = CheckMouse(buttons)
	
' =======================================================================
' Your code goes here
' =======================================================================

	SoundMode = GLISANDO          ' this is what makes the "chirp" sound

' =======================================================================
' Remove next two "REM" statements for simulated monochrome mode
' =======================================================================

	REM SetBWmode ENABLE
	REM SetMonitorColor 6   '1 is blue, 2 is green, 6 is amber, etc...

MainMenu:
	
	FillScreen 1, 1, 25, 80, attr(0, 1), 176, SNOW

	Notice
	Win1 = CurrentWindow

	CloneWindow UBOUND(vcb): Win2 = CurrentWindow
	CloneWindow UBOUND(vcb): Win3 = CurrentWindow

	vcb(Win2).attr = 31: vcb(Win2).Options = SELECTABLE: vcb(Win2).shadow = 1
	vcb(Win3).attr = 30: vcb(Win3).Options = SELECTABLE: vcb(Win3).shadow = 1

	DisplayWindow Win2, 12, 37, 12, 24
	DisplayWindow Win3, 8, 50, 12, 24

	row = 1: col = 1: WinSize = 3
	
	WHILE INKEY$ = ""

		SELECT CASE WinSize
			CASE 3
				size = 3
			CASE 12
				size = -3
			CASE ELSE
		END SELECT

		SELECT CASE row
			CASE 1
				cdirection = 1
			CASE 9
				rdirection = 0
				cdirection = -1
			CASE ELSE
		END SELECT

		col = col + cdirection

		SELECT CASE col
			CASE 1
				rdirection = -1
				cdirection = 0
			CASE 55
				cdirection = 0
				rdirection = 1
			CASE ELSE
		END SELECT
		
		row = row + rdirection

		IF (row = 1) AND (col = 1) THEN
			rdirection = 0
			cdirection = 0
		END IF

		RefreshMode DISABLE                ' Speeds Up the next operations
		
		ReAlignWindow Win2, row, col
		ReAlignWindow Win3, row, col

		RefreshMode ENABLE                 ' Turn refreshing back on

		RefreshWindow Win2                 ' update - starting from Win2
		
	WEND
	
	CloseWindow Win2
	CloseWindow Win3

