REM $DYNAMIC
DEFINT A-Z

CONST CLICKER% = 1
CONST BEEPER% = 2
CONST GLISANDO% = 3
CONST ENABLE% = 1
CONST DISABLE% = 0
CONST OFFBUTTON% = 1
CONST RESIZEBUTTON% = 2
CONST DRAGBAR% = 4
CONST HORZSCROLLBAR% = 8
CONST VERTSCROLLBAR% = 16
CONST SELECTABLE% = 64
CONST FLAT% = 128
CONST NOCOMPRESS% = 256
CONST AUTOCLOSE% = 512
CONST HELPSCROLL% = 1024
CONST ZEROMEM% = 2048
CONST AUTOSCROLL% = 8192

TYPE wincb
     row AS INTEGER
     col AS INTEGER
     rows AS INTEGER
     cols AS INTEGER
     attr AS INTEGER
     Border AS INTEGER
     Shadow AS INTEGER
     Zoom AS INTEGER
     ptr AS INTEGER
     cbytes AS INTEGER
     abytes AS INTEGER
END TYPE

TYPE vircb
     row AS INTEGER
     col AS INTEGER
     rows AS INTEGER
     cols AS INTEGER
     vrow AS INTEGER
     vcol AS INTEGER
     vrows AS INTEGER
     vcols AS INTEGER
     attr AS INTEGER
     Border AS INTEGER
     Shadow AS INTEGER
     Zoom AS INTEGER
     WI AS INTEGER
     Options AS INTEGER
     TitlePos AS INTEGER
     Title AS STRING * 20
     buttons AS INTEGER
     LastButton AS INTEGER
     VertPos AS INTEGER
     HorzPos AS INTEGER
     Signature AS INTEGER
END TYPE

TYPE InkeyRec
     Length AS INTEGER
     ShiftState AS INTEGER
     KeyChar AS STRING * 1
     KeyValue AS INTEGER
     AltChar AS STRING * 1
     AltValue AS INTEGER
     ExtChar AS STRING * 2
     ExtValue AS INTEGER
END TYPE

TYPE EventCoords
     event AS INTEGER
     row AS INTEGER
     col AS INTEGER
END TYPE

DECLARE FUNCTION GetEvent% (mode%)
DECLARE FUNCTION ScanQuickKeys% (K$)
DECLARE SUB QuickKey (Location%, Keypress$)
DECLARE SUB SetCalendar (Handle%, row%, col%, Attrib%, status%)
DECLARE SUB SetClock (Handle%, row%, col%, Attrib%, status%)

DECLARE FUNCTION BWattr% (Attrib%)
DECLARE FUNCTION VideoPage% ()
DECLARE FUNCTION VideoBoard% ()
DECLARE FUNCTION VideoPageLength% ()
DECLARE FUNCTION ScreenMode% ()
DECLARE SUB SetVideoInfo (Segment%, Offset%, rows%, cols%)
DECLARE SUB GetVideoInfo (Segment%, Offset%, rows%, cols%)
DECLARE SUB FillBuffer (Segment%, Offset%, size%, char%, Attrib%)
DECLARE SUB InitVideo ()

DECLARE FUNCTION attr% (f%, b%)
DECLARE FUNCTION BinAttr% (Fore%, Back%, high%, Blink%)
DECLARE FUNCTION FREEWINDOW% ()
DECLARE FUNCTION GetVirtualPtr% (Handle%)
DECLARE FUNCTION IsBWmode% ()
DECLARE FUNCTION WhatWindow% (row%, col%)

DECLARE SUB ClearWindow ()
DECLARE SUB Click ()
DECLARE SUB CloneWindow (Handle%)
DECLARE SUB CloseWindow (Handle%)
DECLARE SUB ColorScreen (row%, col%, rows%, cols%, Attrib%, SNOW%)
DECLARE SUB Copyright (row%, col%)
DECLARE SUB csprint (row%, col%, qattr%, StrDat$)
DECLARE SUB cwcprint (row%, qattr%, StrDat$)
DECLARE SUB cwprint (row%, col%, qattr%, StrDat$)
DECLARE SUB DisplayWindow (Handle%, row%, col%, rows%, cols%)
DECLARE SUB DrawBox (row%, col%, rows%, cols%, qattr%, brdrsel%)
DECLARE SUB FillScreen (row%, col%, rows%, cols%, Attrib%, char%, SNOW%)
DECLARE SUB ForceWindow (Handle%)
DECLARE SUB GetScreen (row%, col%, rows%, cols%, Segment%, Offset%, SNOW%)
DECLARE SUB GrabWindow (Handle%)
DECLARE SUB HideWindow (Handle%)
DECLARE SUB HotPrint (row%, col%, Attr1%, Text$, Attr2%, HotChar$)
DECLARE SUB InitPro ()
DECLARE SUB MainWindow (Handle%)
DECLARE SUB MakeWindow (row%, col%, rows%, cols%, qattr%, brdrsel%, Shadow%, Zoom%, SNOW%)
DECLARE SUB MoveWindow (Handle%, row%, col%)
DECLARE SUB nprint (row%, col%, qattr%, UsingMask$, Number#)
DECLARE SUB Notice ()
DECLARE SUB OpenWindow (Handle%, rows%, cols%, Attrib%, Border%, Shadow%, Zoom%, Options%)
DECLARE SUB PopSound ()
DECLARE SUB PopWindow (row%, col%, rows%, cols%, qattr%, brdrsel%, Shadow%, Zoom%)
DECLARE SUB PutScreen (row%, col%, rows%, cols%, Segment%, Offset%, SNOW%)
DECLARE SUB ReAlignWindow (Handle%, row%, col%)
DECLARE SUB ReCycleMode (mode%)
DECLARE SUB RefreshAllWindows ()
DECLARE SUB RefreshMain ()
DECLARE SUB RefreshMode (mode%)
DECLARE SUB RefreshWindow (Handle%)
DECLARE SUB RemoveSound ()
DECLARE SUB RemoveWindow ()
DECLARE SUB ResizeWindow (Handle%, rows%, cols%)
DECLARE SUB ScrollScreen (row%, col%, rows%, cols%, Attrib%, slines%, sdir%)
DECLARE SUB SetBWmode (mode%)
DECLARE SUB SetMonitorColor (Kolor%)
DECLARE SUB SetWindow (Handle%)
DECLARE SUB SetShadow (mode%, Attrib%)
DECLARE SUB SetZoomSpeed (miliseconds%)
DECLARE SUB SetZoomStyle (FadeMode%)
DECLARE SUB ShowWindow (row%, col%, rows%, cols%, vrow%, vcol%)
DECLARE SUB sprint (row%, col%, Attrib%, StrDat$, SNOW%)
DECLARE SUB TitleWindow (DirPos%, Title$)
DECLARE SUB UnAttr (Attrib%, Fore%, Back%)
DECLARE SUB UnBinAttr (Attrib%, Fore%, Back%, high%, Blink%)
DECLARE SUB vprint (row%, col%, Attrib%, StrDat$, SNOW%)
DECLARE SUB wcprint (row%, StrDat$)
DECLARE SUB wlocate (row%, col%)
DECLARE SUB wprint (row%, col%, StrDat$)

DECLARE FUNCTION CheckMouse% (buttons%)
DECLARE FUNCTION GetMouse% (row%, col%)
DECLARE FUNCTION GetButtonPress% (button%, presses%, row%, col%)
DECLARE FUNCTION GetButtonRelease% (button%, presses%, row%, col%)
DECLARE FUNCTION mousemask% (displaychar%, Fore%, Back%, high%, blnk%)
DECLARE SUB MouseCursorOn ()
DECLARE SUB MouseCursoroff ()
DECLARE SUB SetMouse (row%, col%)
DECLARE SUB SetMouseWindow (row%, col%, rows%, cols%)
DECLARE SUB SetMouseCursor (ctype%, scrnmask%, cursormask%)
DECLARE SUB MouseKillWindow (row%, col%, rows%, cols%)
DECLARE SUB SetMouseMode (newmode%)
DECLARE SUB GetWindowMouse (button%, frow%, fcol%, frows%, fcols%, row%, col%)

COMMON SHARED /VideoData/ MAXROWS AS INTEGER, MAXCOLS AS INTEGER, VIDEOSEGMENT AS INTEGER, VIDEOOFFSET AS INTEGER
COMMON SHARED /WindowData/ wcb() AS wincb, scrn() AS INTEGER, WI AS INTEGER, SoundMode AS INTEGER, SNOW AS INTEGER, CreateMode AS INTEGER, ERRNO AS INTEGER
COMMON SHARED /wprintData/ WindowSeg AS INTEGER, WindowOff AS INTEGER, WindowSize AS INTEGER, WindowSig AS INTEGER
COMMON SHARED /VLSdata/ VirMem() AS INTEGER, vcb() AS vircb, wcbndx() AS INTEGER, CurrentWindow AS INTEGER, UpdateMode AS INTEGER, GlobalOptions AS INTEGER, FreezeFrame AS INTEGER, VideoRecycle AS INTEGER
COMMON SHARED /DialogData/ Keyboard AS InkeyRec, WindowEvent AS INTEGER, WindowHandle AS INTEGER, MenuItem AS INTEGER, KeyBuffer$
COMMON SHARED /QuickKey/ QuickKeys AS INTEGER, QuickKeyEvent AS INTEGER
COMMON SHARED /MouseEvents/ DataEvent AS EventCoords, UserEvent AS EventCoords

