
'Program: MAKE.BAS, (C)1990, by Robert Schoolfield.
'Uses...: PRO.LIB BASIC7.LIB PDQ.LIB

'begin make
'  \bc7\binb\bc
'  \bc7\binb\link
'  basic7 pro pdq
'  make /o /s
'  vertmenu /o /ah
'  picklist /o /ah
'  end source
'  _flush
'  _kill
'  _locate
'  _noerror
'  _noread
'  _noval
'  _pdqval
'  _sort
'  end objects
'  /nod /noe
'end make



'Version Changes:
'2.0 First release.
'2.1 Added timer.
'3.0 Added stub file support.
'3.1 Fixed /NOE duplication.
'3.2 Added make instructions to source instead of seperate file.
'3.3 Fixed bug, was duplicating compile switches.
'3.4 Increased BC switches from 5 to 10
'3.5 Added overLay support.
'3.6 Added ESC abort to compiler loop.
'3.7 Added /I insert directives switch.
'4.0 PDQ Link.  Added PDQ stub file insert.
'4.1 Added seperate directives for BASCOM 7.1 and PDQ.  Added vertical menu
'    prompt for make type: compile, link, both, quit.


DEFINT A-Z

DECLARE SUB Help ()
DECLARE SUB PickList (Items$(), Picked%(), NPicked%, Cnf AS ANY)
DECLARE SUB Parse (Work$, Delimiter$, Array$())
DECLARE SUB InsertDir ()
DECLARE SUB StripRem (InputLine$)
DECLARE SUB FStamp (BaseName$, X$, Y$)
DECLARE SUB PDQCPrint (Mess$, A%,B%)

DECLARE FUNCTION Exist% (FileName$)
DECLARE FUNCTION PDQTimer& ()

'For the Vertmenu module...
DECLARE FUNCTION Monitor% ()
DECLARE SUB ShowCursor ()
DECLARE SUB HideCursor ()
DECLARE SUB TextCursor (FG, BG)
DECLARE SUB VertMenu (Item$(), Choice, MaxLen, BoxBot, Ky$, Action, Cnf AS ANY)


TYPE FileType                             'Define the type of info returned
  Year  AS INTEGER                        'by the FileInfo ASM routine...
  Month AS INTEGER
  Day   AS INTEGER
  Hour  AS INTEGER
  Minute AS INTEGER
  Second   AS INTEGER
  Size AS INTEGER
  Attrib AS INTEGER
END TYPE

DIM Info AS FileType

'The first $Include file contains a structure definition for the menu and
'screen colors.  The second $Include determines the type of monitor you
'are using and assigns the appropriate colors.
'
'$INCLUDE: 'DefCnf.BI'                    'Structure definition for the menu...
'$INCLUDE: 'SetCnf.BI'                    'Determines the type of monitor...



DIM Source$(30)
DIM Picked%(30)
DIM Part$(20)
DIM Obj$(30)
DIM Switches$(30)
DIM PickSource$(30)
DIM OverlayFlag%(30)
DIM COMLine$(3)
DIM SHARED SourceFile$, ProgName$
DIM MenuOption$(4)
'===============================  Begin  ================================

PRINT
PRINT "ESD (R) QuickBASIC/BASCOM7 MAKE Utility, Version 4.1"
PRINT "Copyright (C) 1990 by Robert Schoolfield.  All Rights Reserved."
PRINT


Lin% = CSRLIN                             'Save the current cursor position...
Col% = POS(0)


Work$ = RTRIM$(UCASE$(COMMAND$))

Delim$ = " "
IF RTRIM$(Work$) = "" THEN CALL Help

CALL Parse(Work$, Delim$, COMLine$())

ProgName$ = COMLine$(1)
IF RIGHT$(ProgName$, 4) <> ".BAS" THEN SourceFile$ = ProgName$ + ".BAS"
IF COMLine$(2) = "/I" THEN CALL InsertDir
'SLEEP 1


Delim$ = ", "                             'For the parse sub...
Done% = 0
IF Exist%(SourceFile$) THEN                 'Read in the contents...
  OPEN SourceFile$ FOR INPUT AS 1
  'Seq input until the begin make flag is found...
  DO
    LINE INPUT #1, InputLine$
    A$ = UCASE$(InputLine$)
    IF INSTR(A$, "BEGIN MAKE") THEN Done% = -1
    IF EOF(1) THEN
      BEEP
      CLOSE 1
      PRINT "MAKE: directives not found in "; SourceFile$
      END
    END IF
  LOOP UNTIL Done%

  LINE INPUT #1, InputLine$
  CALL StripRem(InputLine$)
  BCPath$ = RTRIM$(InputLine$)
  
  LINE INPUT #1, InputLine$
  CALL StripRem(InputLine$)
  LinkPath$ = RTRIM$(InputLine$)
 
  LINE INPUT #1, InputLine$
  CALL StripRem(InputLine$)
  LibPath$ = RTRIM$(InputLine$)

  I = 0
  NumberOfSourceFiles% = 0
  DO                                      'Load in the source files...
    LINE INPUT #1, InputLine$
    CALL StripRem(InputLine$)
    I = I + 1
    IF INSTR(InputLine$, "END SOURCE") THEN
      NumberOfSourceFiles% = I - 1
      EXIT DO
    END IF
    Part$(2) = "": Part$(3) = "": Part$(4) = "": Part$(5) = "": Part$(6) = "":  Part$(7) = "": Part$(8) = "": Part$(9) = "": Part$(10) = "": Part$(11) = ""
    CALL Parse(InputLine$, Delim$, Part$())  'Parse out the source filenames from
    A$ = RTRIM$(Part$(1))                    'the command line switches...
    IF LEFT$(A$, 1) = "(" THEN               'Check to see if this source
      A% = LEN(A$) - 2                       'module is an overlay.
      Source$(I) = MID$(A$, 2, A%)
      OverlayFlag%(I) = -1
    ELSE
      Source$(I) = A$
    END IF
    A$ = Part$(2) + Part$(3) + Part$(4) + Part$(5) + Part$(6) + Part$(7) + Part$(8) + Part$(9) + Part$(10) + Part$(11)
    Switches$(I) = RTRIM$(A$) + ";"
  LOOP

  NumberOfObjects% = 0
  I = 0
  DO                                      'Load in the stub files...
    LINE INPUT #1, InputLine$
    CALL StripRem(InputLine$)
    I = I + 1
    IF INSTR(InputLine$, "END OBJECT") THEN
      NumberOfObjects% = I - 1
      EXIT DO
    END IF
    Obj$(I) = InputLine$
  LOOP

  LINE INPUT #1, InputLine$
  CALL StripRem(InputLine$)
  LinkOpts$ = InputLine$
  IF INSTR(LinkOpts$, "/NOE") = 0 AND NumberOfObjects% > 1 THEN
    LinkOpts$ = LinkOpts$ + "/NOE"
  END IF
  CLOSE 1

  FOR I = 1 TO NumberOfSourceFiles%       'Load the PickList array with the
    FileName$ = Source$(I) + ".BAS"       'source file names, dates & times...
    CALL FileInfo(FileName$, SEG Info)
    SourcePad% = 14 - LEN(FileName$)
    ACoupleSpaces$ = "  "
    TheDate$ = LTRIM$(STR$(Info.Month)) + "-" + LTRIM$(STR$(Info.Day)) + "-" + LTRIM$(STR$(Info.Year))
    TheTime$ = LTRIM$(STR$(Info.Hour)) + ":" + LTRIM$(STR$(Info.Minute)) + ":" + LTRIM$(STR$(Info.Second))
    TheLine$ = FileName$ + STRING$(SourcePad%, 32) + TheDate$ + ACoupleSpaces$ + TheTime$
    Pad% = 37 - LEN(TheLine$)
    PickSource$(I) = TheLine$ + STRING$(Pad%, 32)
  NEXT

  print
  print
  Mess$ = "MAKE: Choose files to build, hit ESC to continue..."
  Print Mess$

  LOCATE 3, 16                            'Show the source files in a menu...
  CALL PickList(PickSource$(), Picked%(), NPicked%, Cnf)
 
  FOR I = 1 TO NumberOfSourceFiles%       'Stamp all the source files with
    BasName$ = Source$(I) + ".BAS"        'the same time and date...
    CALL FStamp(BasName$, "*", "*")
  NEXT

  Choice% = 0             'The first selection...
  LOCATE 4, 27            'set upper left corner of menu, turn off the cursor
  Action% = 0
  MaxLen = 16             'this is the menu width
  BoxBot = 20             'limit the box length to go no lower than line 20

  MenuOption$(1) = "Compile and Link"
  MenuOption$(2) = "Compile only"
  MenuOption$(3) = "Link only"
  MenuOption$(4) = "Bow out"
  CALL VertMenu(MenuOption$(), Choice%, MaxLen, BoxBot, Ky$, Action, Cnf)
  
  LOCATE Lin%, Col%                       'Restore the original cursor posit...

  StartTime& = PDQTimer&
  WHILE INKEY$ > "": WEND                 'Flush the kb buffer...

  SELECT CASE Choice%
    CASE IS = 1
      GOSUB CompileSource
      GOSUB LinkObjects
    CASE IS = 2
      GOSUB CompileSource
    CASE IS = 3
      GOSUB LinkObjects
    CASE IS = 4
      END
  END SELECT
      
  EndTime& = PDQTimer&
  
  PRINT "Make: "; (EndTime& - StartTime&) \ 18; "seconds."
  PRINT
ELSE
  BEEP
  PRINT "MAKE: Cannot find source file.  Use the /? command line switch for help..."
END IF
       
END

'================================  Sub Routines  ============================
CompileSource:
  FOR I = 1 TO NPicked%                   'Compile the chosen source files...
    BasName$ = Source$(Picked%(I)) + ".BAS"
    ObjName$ = Source$(Picked%(I)) + ".OBJ"
    Nul$ = "nul.lst"
    PRINT
    Mess$ = "MAKE: Compiling " + BasName$ + " " + Switches$(Picked%(I)) + " Hit ESC to abort process."
    Print Mess$
    PRINT
    Compile$ = BCPath$ + " " + BasName$ + ", " + ObjName$ + ", " + Nul$ + " " + Switches$(Picked%(I))
    'Temp
    SHELL Compile$
    IF INKEY$ = CHR$(27) THEN
      PRINT "Process aborted by user."
      END
    END IF
  NEXT
  RETURN

LinkObjects:
  Object$ = ""                            'Link 'em together...
  Map$ = ProgName$ + ".MAP"
  ExeName$ = ProgName$ + ".EXE"
  TempFile$ = "MAKE_TMP.RSP"
  IF Exist%(TempFile$) THEN KILL TempFile$
  OPEN TempFile$ FOR OUTPUT AS 2
  FOR I = 1 TO NumberOfSourceFiles%
    IF OverlayFlag%(I) THEN               'Put ()'s on the OBJ file if it
      A$ = "(" + Source$(I) + ")"         'should be an overlay...
      Source$(I) = A$
    END IF
    Object$ = Object$ + Source$(I) + " "
    IF I = NumberOfSourceFiles% THEN
      IF NumberOfObjects% > 0 THEN
        PRINT #2, Source$(I) + " +"
      ELSE
        PRINT #2, Source$(I)
      END IF
    ELSE
      PRINT #2, Source$(I) + " +"
    END IF
  NEXT
  FOR I = 1 TO NumberOfObjects%
    Object$ = Object$ + Obj$(I) + " "
    IF I = NumberOfObjects% THEN
      PRINT #2, Obj$(I)
    ELSE
      PRINT #2, Obj$(I) + " +"
    END IF
  NEXT
  PRINT #2, ExeName$
  PRINT #2, Map$
  PRINT #2, LibPath$ + " " + LinkOpts$ + ";"
  CLOSE 2
  'temp
  'END
  Link$ = LinkPath$ + " @" + TempFile$
  PRINT
  Mess$ = "MAKE: Linking " + Object$  + " Hit CTRL-C to abort process."
  Print Mess$
  PRINT
  'temp  
  SHELL Link$
  KILL TempFile$
  PRINT
  RETURN












SUB Help
'=================================  Help  ================================
PRINT
PRINT "Usage:"
PRINT "        MAKE [sourcefilename] [/I]"
PRINT
PRINT "Where:  sourcefilename is the main module to compile/link.  Source main "
PRINT "        module must have the following MAKE instructions in REMmed statements"
PRINT "        near the top of the file.  Specifing the /I switch will insert the "
PRINT "        MAKE directives and some notes.  These directives will require "
PRINT "        editing to suit your code."
PRINT
PRINT "'begin make"
PRINT "'  [path\bc]"
PRINT "'  [path\link]"
PRINT "'  [path\libname]"
PRINT "'  [source name, main module]"
PRINT "'  [source name, other modules]"
PRINT "'        ."
PRINT "'        ."
PRINT "[MORE]"
SLEEP
PRINT "'        ."
PRINT "'  end source"
PRINT "'  [object (stub file) name]"
PRINT "'        ."
PRINT "'        ."
PRINT "'        ."
PRINT "'  end object"
PRINT "'  [link options]"
PRINT "'end make"
END

END SUB

SUB InsertDir
'================================= InsertDir  ==================================

PRINT "Inserting MAKE directives."
A$ = "'  " + ProgName$ + " /o /ah"
B$ = "'  " + ProgName$ + " /o /s"
TempFile$ = "MAKE_TMP.RSP"
OPEN TempFile$ FOR OUTPUT AS 1
PRINT #1, " "
PRINT #1, "'Program: " + SourceFile$
PRINT #1, "'"
PRINT #1, "'begin make"
PRINT #1, "'  \bc7\binb\bc"
PRINT #1, "'  \bc7\binb\link"
PRINT #1, "'  pro"
PRINT #1, A$
PRINT #1, "'  end source  "
PRINT #1, "'  noedit "
PRINT #1, "'  nocom   "
PRINT #1, "'  smallerr  "
PRINT #1, "'  nolpt   "
PRINT #1, "'  nofltin     "
PRINT #1, "'  notrnemr.lib     "
PRINT #1, "'  tscnionr    "
PRINT #1, "'  end objects"
PRINT #1, "'  /e /noe"
PRINT #1, "'end make   "
PRINT #1, "'"
PRINT #1, "'"
PRINT #1, "'Notes:"
PRINT #1, "'"
PRINT #1, "'The paths, filenames, command switches and stub files included above will"
PRINT #1, "'not be applicable this source.  The above directives are specific to "
PRINT #1, "'BASCOM7.  They are intended only as a starting point.  It is the developer's"
PRINT #1, "'responsibilty to edit the MAKE directives inserted above."
PRINT #1, " "
PRINT #1, "'noedit        - Removes support for INPUT editor."
PRINT #1, "'nocom         - Removes support for COM routines."
PRINT #1, "'smallerr      - Reduces length of error messages."
PRINT #1, "'nolpt         - Removes support for LPRINTing."
PRINT #1, "'notrnemr.lib  - Removes support for LOG, SIN, COS, TAN, CIRCLE, DRAW...  "
PRINT #1, "'tscnionr      - Removes support for graphics screens."
PRINT #1, "'nofltin       - Removes support for F.P. math when using INPUT, VAL and READ.  "
PRINT #1, "'noems         - Removes support for EMS overlays."
PRINT #1, "'"
PRINT #1, "'"
PRINT #1, "'The following directives are PDQ specific.  If your program uses PDQ, then"
PRINT #1, "'remove the directives above.  See your PDQ manual for a description"
PRINT #1, "'of the following stub files."
PRINT #1, "'"
PRINT #1, "'"
PRINT #1, "'Program: " + SourceFile$
PRINT #1, "'"
PRINT #1, "'begin make"
PRINT #1, "'  \bc7\binb\bc"
PRINT #1, "'  \bc7\binb\link"
PRINT #1, "'  basic7 pro pdq"
PRINT #1, B$
PRINT #1, "'  end source  "
PRINT #1, "'  _flush"
PRINT #1, "'  _kill"
PRINT #1, "'  _locate"
PRINT #1, "'  _noerror"
PRINT #1, "'  _noread"
PRINT #1, "'  _noval"
PRINT #1, "'  _pdqval"
PRINT #1, "'  _sort"
PRINT #1, "'  end objects"
PRINT #1, "'  /noe /nod"
PRINT #1, "'end make   "
PRINT #1, "'"
PRINT #1, "'"
PRINT #1, "'MAKE - Copyright 1990, Electronic Systems Design, Robert Schoolfield"
PRINT #1, " "
CLOSE 1

OPEN TempFile$ FOR APPEND AS 1
OPEN SourceFile$ FOR INPUT AS 2
DO WHILE NOT EOF(2)
  LINE INPUT #2, A$
  PRINT #1, A$
LOOP
CLOSE 1, 2

Bak$ = "SOURCE.BAK"
IF Exist%(Bak$) THEN KILL Bak$
NAME SourceFile$ AS Bak$
NAME TempFile$ AS SourceFile$

PRINT "Completed.  Original source code has been renamed "; Bak$

END

END SUB


SUB StripRem (InputLine$)
'==============================  StripRem  =================================

A$ = UCASE$(RTRIM$(LTRIM$(InputLine$)))    'Strip the spaces, make upper case...

IF INSTR(A$, "'") = 1 THEN            'Strip out the REM's...
  A% = (LEN(A$) - 1)
  B$ = MID$(A$, 2, A%)
ELSEIF INSTR(A$, "REM") = 1 THEN
  A% = (LEN(A$) - 3)
  B$ = MID$(A$, 2, A%)
ELSE
  PRINT : PRINT "MAKE: Direct statement in MAKE instructions."
  END
END IF

InputLine$ = RTRIM$(LTRIM$(B$))


END SUB

