DECLARE FUNCTION AllocMemo& (FileHandle AS ANY, BytesNeeded&)
DECLARE SUB InsertMemo (FileHandle AS ANY, MemoText$, Location&)
DECLARE FUNCTION RetrieveMemo$ (FileHandle AS ANY, Location&)
DECLARE SUB DeAllocMemo (FileHandle AS ANY, Location&)
DECLARE SUB RetrieveMsgs (FileHandle AS ANY, L&())
DECLARE SUB PackMemo (FileHandle AS ANY, L&(), FileName$)

KILL "memo.dat"
Memo = FREEFILE
OPEN "memo.dat" FOR BINARY AS Memo

DIM Location&(4), Msg$(4)

Msg$(1) = "Message 1"
Msg$(2) = "Message 22"
Msg$(3) = "Message 333"

'Put the messages in the file
FOR i = 1 TO 3
  Location&(i) = AllocMemo&(Memo, LEN(Msg$(i)))
  InsertMemo Memo, Msg$(i), Location&(i)
NEXT i
RetrieveMsgs Memo, Location&()

'Delete msg 3
DeAllocMemo Memo, Location&(3): Location&(3) = 0

'Insert another message 2 into location 3
Location&(3) = AllocMemo(Memo, LEN(Msg$(2)))
InsertMemo Memo, Msg$(2), Location&(3)

'Print the messages
RetrieveMsgs Memo, Location&()

'Insert a long message in location 4
Msg$(4) = "Message 4444"
Location&(4) = AllocMemo(Memo, LEN(Msg$(4)))
InsertMemo Memo, Msg$(4), Location&(4)

'Print the messages
RetrieveMsgs Memo, Location&()

'Delete message 4
DeAllocMemo Memo, Location&(4): Location&(4) = 0

'Put an even longer message 
Msg$(4) = "Message 55555"

Location&(4) = AllocMemo(Memo, LEN(Msg$(4)))
InsertMemo Memo, Msg$(4), Location&(4)

'Print the messages
RetrieveMsgs Memo, Location&()

'delete 2nd message
DeAllocMemo Memo, Location&(2): Location&(2) = 0

RetrieveMsgs Memo, Location&()
PackMemo Memo, Location&(), "MEMO.DAT"
CLOSE Memo

FUNCTION AllocMemo& (FileHandle, BytesNeeded&)
IF BytesNeeded& < 4 THEN BytesNeeded& = 4
IF LOF(FileHandle) = 0 THEN
  Head& = 0&
  FileLen& = 8&
  PUT FileHandle, , Head&
  PUT FileHandle, , FileLen&
  FilePos& = FileLen& + 1
  Blanks$ = SPACE$(BytesNeeded& + 4)
  PUT FileHandle, FilePos&, Blanks&
  FileLen& = FileLen& + BytesNeeded& + 4
  PUT FileHandle, 5, FileLen&
ELSE
'Search chain
  GET FileHandle, 1, Head&
  GET FileHandle, , FileLen&
  IF Head& = 0 THEN
   FilePos& = FileLen& + 1
   Blanks$ = SPACE$(BytesNeeded& + 4)
   PUT FileHandle, FilePos&, Blanks&
   FileLen& = FileLen& + BytesNeeded& + 4
   PUT FileHandle, 5, FileLen&
  ELSE
   Current& = Head&
   Nxt& = Head&
   Previous& = 1&
   DO
    IF Current& <> Head& THEN Previous& = Current&
    Current& = Nxt&
    GET FileHandle, Current&, BytesAvail&
    GET FileHandle, LOC(FileHandle), Nxt&
   LOOP UNTIL Nxt& = 0 OR BytesAvail& > BytesNeeded&
   IF BytesAvail& > BytesNeeded& THEN
    FilePos& = Current&
    'Put chain back together
    PUT FileHandle, Previous&, Nxt&
   ELSE
    FilePos& = FileLen& + 1
    Blanks$ = SPACE$(BytesNeeded& + 4)
    PUT FileHandle, FilePos&, Blanks&
    FileLen& = FileLen& + BytesNeeded& + 4
    PUT FileHandle, 5, FileLen&
   END IF
  END IF
END IF
AllocMemo& = FilePos&
END FUNCTION

SUB DeAllocMemo (FileHandle, Location&)
 'Add this location to the chain
 'Put this chunk at the beginning of the chain
 GET FileHandle, 1, Nxt&
 PUT FileHandle, 1, Location&
 Location& = Location& + 4
 PUT FileHandle, Location&, Nxt&
END SUB

SUB InsertMemo (FileHandle, MemoText$, FilePos&)
 TotalBytes& = LEN(MemoText$)
 IF TotalBytes& < 4 THEN
  MemoText$ = MemoText$ + SPACE$(4 - TotalBytes&)
  TotalBytes& = 4
 END IF
 PUT FileHandle, FilePos&, TotalBytes&
 PUT FileHandle, , MemoText$
END SUB

SUB PackMemo (FileHandle, L&(), FileName$)
DIM i AS LONG
NewFile = FREEFILE
OPEN "XXXXXXXX.XXX" FOR BINARY AS NewFile
FOR i = 1 TO UBOUND(L&)
  IF L&(i) THEN
    Msg$ = RetrieveMemo$(FileHandle, L&(i))
    L&(i) = AllocMemo&(NewFile, LEN(Msg$))
    InsertMemo NewFile, Msg$, L&(i)
  END IF
NEXT i
CLOSE FileHandle, NewFile
KILL FileName$
NAME "XXXXXXXX.XXX" AS FileName$
FileHandle = FREEFILE
OPEN FileName$ FOR BINARY AS FileHandle
END SUB

FUNCTION RetrieveMemo$ (FileHandle, Location&)
 GET FileHandle, Location&, TotalBytes&
 m$ = SPACE$(TotalBytes&)
 GET FileHandle, , m$
 RetrieveMemo$ = m$
 m$ = ""
END FUNCTION

SUB RetrieveMsgs (FileHandle, L&())
FOR i = 1 TO UBOUND(L&)
 PRINT i;
   IF L&(i) THEN
    Msg$ = RetrieveMemo$(FileHandle, L&(i))
    PRINT Msg$
   ELSE
    PRINT
   END IF
NEXT i
PRINT "--------"
END SUB

