' ͻ
'  Copyright (c) 1991 by Thomas Jaeger, CZAR SOFTWARE 
' ͼ
' Thomas Jaeger, CZAR SOFTWARE
' 1848 Andalucia Drive
' El Paso, TX 79935
' USA
'
' This program (NACDI) is to distribute as PUBLIC DOMAIN to all fellow
' QuickBASIC programmers.

' Near Assembler Clock-Display Information (NACDI)
' 
' Program sets a 24 hour clock on upper right corner
' It will display hours, mintes, and seconds e.g. 15:36:02 permanently.
'
' This routine is extremly fast because it writes directly to the
' screen which you usually see only on ASSEMBLER routines.
' I use a GOSUB here because it's faster than a SUB call and speeds
' it up even more. COUTION! If you need to change the whole screen
' to display something else, just switch off the TIMER with the
' command TIMER OFF and then switch it back on later with TIMER ON.

DEFINT A-Z                      ' Set all variables to 2 byte integers
SCREEN 0                        ' Set text-only screen mode
IF PEEK(&H449) = 7 THEN         ' If screen is monochrome then
   ScreenSeg = &HB000           '    set the screen segment to monochrome
ELSE                            ' Else
   ScreenSeg = &HB800           '    set the screen segment to color
END IF                          ' End

ON TIMER(1) GOSUB Clock         ' Tell BASIC where to go when TIMER is on
TIMER ON                        ' Switch timer on

'   Your code goes here!        ' Here would be your normal code.
'   .                           ' Even several LOCATE statements and
'   .                           ' screen changes do NOT disturb or mess
'   .                           ' up the clock display which happens with
'   .                           ' many other BASIC routines.

COLOR 7, 2                      ' Change color to white forground and
                                ' green background
CLS                             ' Clear screen with the new color
DO                              ' Do nothing loop until key is pressed
LOOP UNTIL INKEY$ <> ""         ' (only for demo purposes)
COLOR 7, 0                      ' Change color back to white forground and
                                ' black background
END                             ' End of program

Clock:
   DEF SEG = ScreenSeg          ' Set Screen Address
   Watch$ = TIME$               ' Set Watch$ with current time
   LetterPosition = 1           ' Initialize LetterPosition by 1
   FOR ScreenPosition = 144 TO 158 STEP 2
      ' 144 = The start position on upper right corner.
      ' You can change 144 to change the start position of the clock but
      ' you must always get 14 between the two numbers for the loop and
      ' both numbers have to be even numbers (2, 4, 6, 8, etc.).
      ' For example, FOR ScreenPosition = 2 TO 16 STEP 2 which will
      ' position the clock on the left upper corner + 1 position.

      Letter$ = MID$(Watch$, LetterPosition, 1)
      ' Read Watch$ variable

      POKE ScreenPosition, ASC(Letter$)
      ' Write to screen address position

      POKE ScreenPosition + 1, 112
      ' 112 = Black on White
      ' 0   - 15  (15 = Bright white on Black)
      ' 16  - 31  (31 = Bright white on Blue)
      ' 32  - 47  (47 = Bright white on Green)
      ' 48  - 63  (63 = Bright white on Cyan)
      ' 64  - 79  (79 = Bright white on Red)
      ' 80  - 95  (95 = Bright white on Magenta)
      ' 96  - 15  (15 = Bright white on Brown)
      ' 112 - 127 (15 = Bright white on White)
      '
      ' Color range:
      ' 0 = Black, 1 = Blue, 2 = Green, 3 = Cyan, 4 = Red, 5 = Magenta
      ' 6 = Brown, 7 = White, 8 = Gray, 9 = Light Blue, 10 = Light green
      ' 11 = Light cyan, 12 = Light red, 13 = Light magenta, 14 = Yellow
      ' 15 = High-intensity white

      LetterPosition = LetterPosition + 1   ' Increment LetterPosition by 1
   NEXT
   ' Increment ScreenPosition by 2.
   ' Notice I did not use NEXT ScreenPosition which would have taken more
   ' space and speed.

   DEF SEG                      ' Return to BASIC DGROUP
   RETURN                       ' Return from Subroutine

