'------------------------------------------------------------------------
'                               NUMSTR.BAS
'------------------------------------------------------------------------
'     (C) Copyright 1990, Jerry Owens dba Vanguard Management Systems
'                      P.O. Box 1582 - Tupelo, MS 38802
'------------------------------------------------------------------------                 
'
'           Purpose: Returns a variable length formated string, given
'                    a beginning numeric string and a pattern mask.
'
'        Written by: Jerry Owens
'              Date: 11/24/90
'  
'       Modified by: Jerry Owens
'              Date: 12/12/90
'           
'
'            Syntax: Num$ = "123456789" : Mask$ = "   -   -     "
'            SSNum$ = NumStr$(Num$, Mask$)
'
'            Result: 123-45-6789
'
'
'
'
'-------------------------------------------------------------------------

DEFINT A-Z

DECLARE FUNCTION NumStr$ (N AS STRING, Mask AS STRING)


'-------------------------- Test Module ----------------------------------

DIM SHARED oops AS INTEGER


DO WHILE Num& <> -1
    oops = -1
    INPUT "Enter Number and Mask test NumStr"; Num$, Mask$
    PRINT ">> NumStr$ = "; NumStr((Num$), Mask$); "   oops ="; oops
    PRINT
LOOP
STOP
END

'------------------------------ Function Numstr ----------------------------

FUNCTION NumStr$ (Nums AS STRING, Mask AS STRING)
    DIM Tmp AS STRING, MChar AS STRING, NChar AS STRING
    DIM MaskLen  AS INTEGER
    
    
    MaskLen = LEN(Mask)
    IF MaskLen = 0 THEN GOTO done
    Tmp = ""
    Nums = RIGHT$(STRING$(MaskLen, "0") + RTRIM$(LTRIM$(Nums)), MaskLen)

    M = MaskLen: N = MaskLen

    DO WHILE (M > 0 AND N > 0)
        MChar = MID$(Mask, M, 1)
        NChar = MID$(Nums, N, 1)
        SELECT CASE MChar
            CASE IS = CHR$(32)
                Tmp = NChar + Tmp
                M = M - 1: N = N - 1
            CASE ELSE
                Tmp = MChar + Tmp
                M = M - 1
        END SELECT
    LOOP
    
    NumStr$ = Tmp: oops = 0
done:

END FUNCTION

