'Ŀ
' P-Screen Demo                                        QuickBASIC 4.x Only  
'Ĵ
' Demo program included with P-Screen (Pro~Formance Screen Design).         
'                                                                           
' Compatibility:   QuickBasic 4.x only (rsLoadScrn uses TYPE, here, SEG)    
'                                                                           
'    3 Purposes:   Demonstrate how to:                                      
'                   1.  Display screens stored in a Library from programs.  
'                       - Press [H]elp to view a Help Screen.  Examine the  
'                         small amount of code needed to display a screen.  
'                                                                           
'                   2.  Display a directory of Library Screen names.        
'                                                                           
'                   3.  Load several screens (Menus) at once, then later    
'                       display 'em on demand.                              
'                                                                           
'        To run:   Run QB, loading a Quick Library that contains:           
'                                                                           
'                  - rsLoadScrn.obj     -rsLodBin.obj      -rsCompRest.obj  
'                                                                           
'                                                                           
'                  We include PS-DEMO.QLB with P-Screen for this purpose.   
'                                                                           
'                  Example:  QB ps-demo /l ps-demo                          
'                                                                           
'       History:   1st cut 12/88                                            
'                  p-screen menus 4/90                                      
'                                                                           
' (C) 1988-1990 R.W. Smetana  

DEFINT A-Z          '... Integers ONLY.  If not, called routines will crash.

'................. .................  ................. .................

'... LoadMenus is a SUB in this module.
DECLARE SUB LoadMenus (MenuDemo%(), Menu.ErrCode%)

'... These SUBs are in PS-Demo.Qlb
DECLARE SUB rsLoadScrn (Array%(), LibraryName$, FileName$, Desc$, LeftRow%, LeftCol%, RhtRow%, RhtCol%, x%, ErrCode%)
DECLARE SUB rsCompRest (LeftRow%, RhtRow%, SEG Array%)
DECLARE SUB CompRestPlus (Left, Lft, Rht, Rht, SEG Array%)

'...Caution:  Use rsCompRest ONLY for full-width screens.  Registered
'   users receive CompRestPlus which can display ANY SIZE screens.
'   P-Screen COMPRESSES screens.  Only our display routines can display 'em.


CONST LibraryName$ = "P-SCREEN"         '... Display all screens from
                                        '    P-Screen.Psl

TYPE ScrLib                             '... TYPE to read Names/Descriptions
    ScrName AS STRING * 8               '    of screens in a Library
    Description AS STRING * 15
    IgnoreMe AS STRING * 14
END TYPE
DIM ScreenLib AS ScrLib

'... If you prefer Field statements over TYPES, use this : : :

'    FIELD #1, 8 AS ScrName$, 15 AS Description$, 14 AS IgnoreMe$


'................. .................  ................. .................


'... 1st, see if "P-Screen.Psl" exists.  If not, stop.

    ON ERROR GOTO CantFindLibrary   '... Demo aborts if P-Screen.Psl isn't found.

    CLOSE : OPEN LibraryName$ + ".Psl" FOR INPUT AS #1  '... Just checking.  Your
    CLOSE                                           '    programs must ensure
                                                    '    Libraries exist BEFORE
                                                    '    calling our routines.

REDIM MenuDemo%(1)                                  '... Load ALL P-Screen-style
CALL LoadMenus(MenuDemo%(), Menu.ErrCode)           '    menus into one array.
                                                    '    Press "M" at the menu
                                                    '    to see the results.
'................. .................  ................. .................

'... Main Menu
   DO
    CLS
      PRINT TAB(33); "P-Screen   Demo"
      a$ = "Do you want Help/Directory/Menu Demo?"    '... Help displays a Help Screen
      b$ = "Press  [H]elp, [D]irectory, [M]enu"       '... Directory displays screens/descriptions
                                                      '    in P-Screen.Psl.  Both are useful.
                                                      '    See MenuDemo for details on it
      c$ = "Esc] = Exit this Demo"
      GOSUB MidMessage                                '... print the Main Menu

      Option$ = UCASE$(INPUT$(1))
      CLS

      ON INSTR("HDM", Option$) GOSUB Help, Directory, MenuDemo

   LOOP UNTIL Option$ = CHR$(27)

END
'................. .................  ................. .................
Help:    '... demonstrate how to Display Library Screen/interpret ErrCode
'................. .................  ................. .................

    ScreenName$ = "QuikRef1"            '... P-Screen's Quick Reference Guide

    REDIM Array%(1)                     '... Load screen into Array%(), then
                                        '    restore screen from Array%(). Don't
                                        '    use Dim.  It's REdimension as needed.
    GOSUB DisplayScreen                 '... That's it.  See below for how it's done
RETURN

'................. .................  ................. .................
DisplayScreen:

'... If we got this far, LibraryName$ + ".Psl" is available on the
'    "current" drive.  So, load ScreenName$ and display it.
'................. .................  ................. .................

    ScreenName$ = UCASE$(ScreenName$)   '... Screen names stored in Upper Case
  
    CALL rsLoadScrn(Array%(), LibraryName$, ScreenName$, Desc$, LeftRow, LeftCol, RhtRow, RhtCol, x, ErrCode)

                                    '... Notes:  rsLoadscrn opens the Screen
                                    '    Library file, searches it's "index"
                                    '    for your screen, then either:
                                    '    - loads it into Array% (calling rsLodBin)
                                    '    - or reports an error if not found, etc.

                                    '    LeftRow/LeftCol/RhtRow/RhtCol define
                                    '    the Original coordinates of the screen.
                                    '    (1/1/25/80 = Rows 1-25, Columns 1-80).
                                    '    ErrCode has 2 MAIN possibilities:::
    SELECT CASE ErrCode

     CASE IS < 0                    'Negative ErrCode means Error (usually -99 or -1)
        BEEP
        IF ErrCode = -99 THEN               '... screen NOT in Library
           PRINT TAB(20); "["; ScreenName$; "]  was NOT in "; LibraryName$; ".Psl";
        ELSE                                '... error loading it (probably -1)
           PRINT " Error loading "; ScreenName$;
        END IF

        GOSUB pause

     CASE ELSE                          '...If POSITIVE, everything went OK
                                        '   ErrCode reports # of bytes loaded.
                                        '...Caution:  Use rsCompRest ONLY
                                        '   for FULL-WIDTH screens.
                                        '   - Registered users receive CompRestPlus
                                        '     to display ANY size full/sub-screen.
                                        '   - The Menu Demo uses CompRestPlus
       
        CALL rsCompRest(LeftRow%, RhtRow%, SEG Array%(1))
        ERASE Array%                    '... no longer needed
       
        GOSUB ShowInfo                  '... for your information

        D$ = INPUT$(1)                  '... pause

    END SELECT
'................. .................  ................. .................
RETURN
'................. .................  ................. .................
ShowInfo:           '... display info returned by rsLoadScrn
'................. .................  ................. .................
      
    COLOR 0, 7
    LOCATE 7, 12: PRINT "" + STRING$(54, 196); ""
        FOR x = 1 TO 8: LOCATE , 12: PRINT ""; SPC(54); "": NEXT
    LOCATE , 12: PRINT "" + STRING$(54, 196); ""

    LOCATE 7, 24: PRINT "rsLoadScrn reported the following:"
    LOCATE 9, 29:  PRINT "Screen:  "; ScreenName$
    LOCATE , 21:  PRINT "Screen Library:  "; LibraryName$
    LOCATE , 24:  PRINT "Description:  "; Desc$
    LOCATE , 19:  PRINT "Top Row / Column: "; LeftRow; LeftCol
    LOCATE , 16:  PRINT "Bottom Row / Column: "; RhtRow; RhtCol
    LOCATE , 26: PRINT "Exit Code: "; ErrCode; "  It went just fine!"

    LOCATE 16, 31: PRINT "Press a key . . .";
    COLOR 7, 0

RETURN

'................. .................  ................. .................
Directory:  '... Demonstrate how to review Library Screen Names/Descriptions
'................. .................  ................. .................
           
    CLOSE
    OPEN Path$ + LibraryName$ + ".PSL" FOR RANDOM AS #1 LEN = LEN(ScreenLib)
   
    PRINT TAB(26); "Screens Stored in "; LibraryName$; ".Psl": PRINT
    PRINT TAB(7); "Name"; TAB(17); "Description"; TAB(49); "Name"; TAB(59); "Description"
    PRINT

    FOR x = 2 TO 101                                '... start at record #2
        GET #1, x, ScreenLib                        '... using TYPE format/NOT Field
            a$ = LTRIM$(RTRIM$(ScreenLib.ScrName))  '... strip blanks
            IF a$ = "" THEN EXIT FOR                '1st blank means "all done"
            PRINT USING "  ##. "; x - 1;
            PRINT LEFT$(a$ + SPACE$(10), 10); ScreenLib.Description,
        NEXT
    CLOSE

    GOSUB pause

RETURN
'................. .................  ................. .................
pause:
'................. .................  ................. .................
    LOCATE 24, 20: PRINT SPC(12); "Press a key . . ."; SPC(15);
    a$ = INPUT$(1)                      '... pause

RETURN
'................. .................  ................. .................
MenuDemo:     '... Demonstrate displaying screens from an array.
            '    Uses CompRestPlus (Call CompRestPlus ...) to display ANY
            '    size full screen or sub-screen (registered users only).

            'The array MenuDemo%() was loaded with screens from P-Screen.Psl
            'when you first ran this demo --- Call LoadMenus (MenuDemo%(), Menu.ErrCode).
            'Loading menus from a screen library into an Integer array
            'saves you a few '000 bytes of valuable string/data space.

'NOTE:  If strange things happen when you run this, P-Screen.Psl (or this demo)
'       was probably tampered with.  The Row/Column and MenuDemo% offsets BELOW
'       may no longer be correct.  If not, you'll get bizzare screens.
'............... .................  ................. .................

    IF Menu.ErrCode <> 0 THEN     '... error occurred loading screens
        PRINT TAB(12); "Error occurred loading screens earlier.  Can't do demo."
        BEEP: D$ = INPUT$(1): RETURN
    END IF

'--- We're only interested in "OurKeys$" -- certain (Alt-/Cursor) keys : : :

'... Alt-key scan codes for Alt- : : :

    'F (!), D (" "), B (0), E (Chr$(18)),  O (24), H (#)
        '''F (!), E (Chr$(18)), V (/), S (31), R (19), D (" "), O (24), H (#)

'... Scan codes for Right/Left Cursor keys ==>> M/K.  Escape = Chr$(27)
     '  we want these in a certain order.  Thus the gyrations below.

     OurKeys$ = "! 0" + CHR$(18) + CHR$(24) + "#MK"
        ''OurKeys$ = "!" + CHR$(18) + "/" + CHR$(31) + CHR$(19) + " " + CHR$(24) + "#MK"

     Waitfor! = 1                                   '... length of pause (see below)
     Start = 0                                      '... For Left/Right Cursor

     DO                                             '... Outer Loop

     '>>>> Note the Pause between screens at the end of this loop <<<<

     CLS
     CALL CompRestPlus(1, 1, 1, 80, SEG MenuDemo%(MenuDemo%(1))) '  see note below re: Offsets

     LOCATE 19, 1
        PRINT " These menus are displayed from an INTEGER array, NOT disk.  This demo is to"
        PRINT " show how you can load many screens as a program starts then display 'em later."
        PRINT " See 'Performance Hints' in your manual.  Screens displayed with CompRestPlus."
        PRINT : PRINT TAB(21); "Pausing"; Waitfor!; "second(s) before clearing menus";
    

     LOCATE 25, 6: PRINT "Press:  "; CHR$(27); "/"; CHR$(26); " cursor keys,   or    Alt- F, D, B, E, O, H     [Esc] = Exit";
        ''LOCATE 25, 6: PRINT "Press:  Left/Right Cursor Keys, -or- Alt- F/D/B/E/O/H     [Esc] = Exit";
        ''LOCATE 25, 3: PRINT "Press:  Left/Right Cursor Keys, -or- Alt- F/E/V/S/R/D/O/H     [Esc] = Exit";



        DO                                         '... get a key

          D$ = "": D$ = INKEY$

        LOOP UNTIL (LEN(D$) = 2 AND INSTR(OurKeys$, RIGHT$(D$, 1))) OR D$ = CHR$(27)


        IF D$ = CHR$(27) THEN EXIT DO   '... exit Outer Loop on Esc

        D$ = RIGHT$(D$, 1)              '... It's Extended, take 2nd key/Strip Chr$(0)

        IF INSTR("MK", D$) THEN         '... if Right/Left Cursor then...
           IF D$ = "M" THEN     'right cursor
              Start = Start + 1: IF Start > 6 THEN Start = 1
           ELSE                 'left cursor
              Start = Start - 1: IF Start < 1 THEN Start = 6
           END IF

           '... turn d$ into it's Alt-F equivalent based on Start
           D$ = MID$(OurKeys$, Start, 1)

        END IF
       
        SELECT CASE D$                  '... NOTE:  We reserved the 1st 10
                                        '    elements in MenuDemo%() to store
                                        '    the offset into MenuDemo% where
                                        '    each screen BEGINS.
                                        '    See Sub LoadMenus for details.

          CASE "!"          '... Alt-F (File)
              CALL CompRestPlus(1, 2, 15, 27, SEG MenuDemo%(MenuDemo%(2)))
              Start = 1     '... update where we are in case of Left/Right

          CASE " "          '... Alt-D (Draw)
              CALL CompRestPlus(1, 11, 11, 34, SEG MenuDemo%(MenuDemo%(3)))
              Start = 2     '... update where we are in case of Left/Right

          CASE "0"          '... Alt-B (Block)
              CALL CompRestPlus(1, 20, 17, 43, SEG MenuDemo%(MenuDemo%(4)))
              Start = 3     '... update where we are in case of Left/Right

          CASE CHR$(18)     '... Alt-E (Edit)
              CALL CompRestPlus(1, 30, 9, 50, SEG MenuDemo%(MenuDemo%(5)))
              Start = 4     '... update where we are in case of Left/Right

          CASE CHR$(24)     '... Alt-O (Options)
              CALL CompRestPlus(1, 39, 14, 63, SEG MenuDemo%(MenuDemo%(6)))
              Start = 5     '... update where we are in case of Left/Right

          CASE "#"          '... Alt-H (Help)
              CALL CompRestPlus(1, 51, 10, 75, SEG MenuDemo%(MenuDemo%(7)))
              Start = 6     '... update where we are in case of Left/Right

          CASE ELSE         'nada

        END SELECT

     '--- Pause briefly before we refresh the screen.  To change the length
     '    of the pause, change the value of WaitFor! above the Main Loop.

     x! = TIMER: DO UNTIL TIMER > x! + Waitfor!: LOOP


     LOOP

RETURN
'................. .................  ................. .................
CantFindLibrary:    '... couldn't find LibraryName$ + ".Psl"
'................. .................  ................. .................
    CLS : CLOSE

    PRINT TAB(18); "Can't find "; LibraryName$ + ".Psl.  Press a key . . .";
    BEEP: a$ = INPUT$(1): END

'................. .................  ................. .................

MidMessage:
    COLOR 0, 7
    LOCATE 8, 20: PRINT ""; STRING$(39, ""); ""
    FOR x = 9 TO 13
        LOCATE , 20: PRINT ""; SPACE$(39); ""
    NEXT
    LOCATE , 20: PRINT ""; STRING$(39, ""); ""
    LOCATE 10, 21: PRINT STRING$(38, "")

    LOCATE 9, 22:  PRINT a$
    LOCATE 14, 22: PRINT "["; c$; "]"
    LOCATE 12, 22: PRINT b$;

    a$ = "": b$ = "": c$ = ""
    COLOR 7, 0
RETURN

'................. .................  ................. .................
SUB LoadMenus (MenuDemo%(), Menu.ErrCode)
'................. .................  ................. .................
'   Purpose:  1) Load ALL menu screens from P-Screen.Psl into MenuDemo%()
'                for fast display later on.
'             2) Demonstrate how to do this in your programs -- for those
'                situations needing Instant screens/subscreens
'
'     Calls:  Run only with LoadScrn.obj & rsLodBin.obj in your Quick Library
'................. .................  ................. .................
'... setup
'................. .................  ................. .................
    CLS
  
    REDIM MenuDemo%(1 TO 2000)  '... Less than 2000 bytes FAR memory needed to
                                '    store ALL menus.  Saves lots of string space.
                                '    In your programs, calculate (##) on the fly.
                                '    See commented-out sections below for how.

    REDIM Tmp%(1)               '... Temporary storage for each screen
  
  
    Offset = 10                 '... Offset into MenuDemo% to load each new screen.
                                '    We have 9 screens. Elements 1-9 of MenuDemo%
                                '    store the offset of each screen for re-displaying.
    ScreenNumber = 1            '    To store Offset for re-displaying screen.

'................. .................  ................. .................
'... start loading "Menu" screens
'................. .................  ................. .................

    ScrnN$ = "PSCRTOP1":      GOSUB CalcOffset
  
    ScrnN$ = "PSCRFILE":      GOSUB CalcOffset
  
    ScrnN$ = "PSCRDRAW":      GOSUB CalcOffset
  
    ScrnN$ = "PSCRBLOK":      GOSUB CalcOffset
  
    ScrnN$ = "PSCREDIT":      GOSUB CalcOffset
 
    ScrnN$ = "PSCROPTN":      GOSUB CalcOffset
  
    ScrnN$ = "PSCRHELP":      GOSUB CalcOffset
  

'... NOTE: UNComment next 2 lines (& line near end) if you want to see stats as screens are loaded
  
''   PRINT : PRINT TAB(4); "Press a key . . .";
''   D$ = INPUT$(1)   'pause  '... see below, if you print stats, pause before exit

'................. .................  ................. .................
 EXIT SUB            '... all done
'................. .................  ................. .................

'................. .................  ................. .................
CalcOffset:         '... this does the actual work:  find the right spot
                    '    (Offset) for each new screen, copy screen to MenuDemo%,
                    '    then store Offset in MenuDemo% for displaying
'................. .................  ................. .................
CALL rsLoadScrn(Tmp%(), LibraryName$, ScrnN$, Desc$, LeftRow, LeftCol, RhtRow, RhtCol, ScrnSize, ErrCode)

IF ErrCode < 0 THEN Menu.ErrCode = -99: EXIT SUB   '...tsk tsk, jumping out of a gosub.
                                                 '   just for demo.  Do gracefully in your program.

    FOR x = 1 TO UBOUND(Tmp%)           '... Copy it into MenuDemo%

        IF x + Offset > UBOUND(MenuDemo%) THEN EXIT FOR   '... just in case

        MenuDemo%(Offset + x) = Tmp%(x)   '    NOTE: 1st screen begins at 11
    NEXT                                '    (Offset+x  or 10+1)

    MenuDemo%(ScreenNumber) = Offset + 1  '... Save the beginning of each screen.
                                        '    See MenuDemo to see how MenuDemo%(1-10) are used.
   
   
    ScreenNumber = ScreenNumber + 1     '... bump it for the next screen

    Offset = Offset + ScrnSize          '... Adjust Offset MenuDemo% so next screen
                                        '    is stored after this one.

'... NOTE: UNComment next line (& Pause above) if you want to see stats as screens are loaded

''   PRINT USING " \       \ Size:####  Ends:#####    Top Row/Col  ## ##,   Bottom Row/Col  ## ##"; ScrnN$; ScrnSize; Offset; LeftRow; LeftCol; RhtRow; RhtCol

RETURN
'................. .................  ................. .................

END SUB

