' SRCHPATH.BAS
' $INCLUDE: 'QB.BI'

CONST FALSE = 0, TRUE = NOT FALSE
DIM SHARED InRegs AS RegType, OutRegs AS RegType

DECLARE FUNCTION Exist% (FileName$)

FUNCTION SearchPath$ (SrchFil$) STATIC
' Function to search for the existence of
' a file in any directory in the search path
CurDirChecked% = FALSE
Path$ = ENVIRON$("PATH")
' Don't process a null path
DO WHILE LEN(Path$) > 0
  Found% = FALSE
  ' discard any leading semicolons
  DO WHILE LEFT$(Path$, 1) = ";"
     Path$ = RIGHT$(Path$, LEN(Path$) - 1)
  LOOP
  NextSemi% = INSTR(Path$, ";")
  ' extract the next directory path from the list
  APath$ = LEFT$(Path$, ABS(NextSemi% > 0) * (NextSemi% - 1))
  ' above statement "fails" for last path in the string
  ' (APath$ will be null, and Path contains last path - so swap)
  IF APath$ = "" AND LEN(Path$) > 0 THEN
    SWAP APath$, Path$
  END IF
  ' "pop" the "current" path from the front of the path list
  Path$ = RIGHT$(Path$, ABS(NextSemi% > 0) * ((LEN(Path$) - LEN(APath$)) - 1))
CheckFileExistence:
  ' set up the separator character (if we need to)
  Sep$ = "\"
  IF RIGHT$(APath$, 1) = "\" THEN Sep$ = ""
  ' see if the file exists in the specified path
  IF Exist%(APath$ + Sep$ + SrchFil$) THEN
    Found% = TRUE: EXIT DO
  END IF
  ' once we exhaust the path list, we should
  ' also check the current directory
  IF Path$ = "" AND NOT CurDirChecked% THEN
    APath$ = "."
    CurDirChecked% = TRUE
    GOTO CheckFileExistence
  END IF
LOOP
IF Found% THEN SearchPath$ = APath$
END FUNCTION


FUNCTION Exist% (FileName$) STATIC
' See if a given file exists using
' DOS "Search for first match" service &H4E
 DIM Spec AS STRING * 64
 InRegs.ax = &H4E00 
 InRegs.cx = 63            ' Search for all files
' DOS requires an ASCIIZ string so add CHR$(0)
 Spec = FileName$ + CHR$(0) 
 InRegs.dx = VARPTR(Spec)   ' address of Spec
 Interrupt &H21, InRegs, OutRegs  ' CALL DOS
' If AX contains a value, then file does not exist
 IF OutRegs.ax = 0 THEN Exist% = -1 ELSE Exist% = 0
END FUNCTION
