' PFF - Programmer's File Formatter for DeskJet Printers
' Written by Tim Jones
' Copyright 1988-91 AmSoft Development
' This source is FREE! If you change it, please let me know so I can
' keep track of it.  See readme file for info.


DECLARE SUB AllDone ()
DECLARE SUB ViewHead (VFile$)
DECLARE SUB FormatFile (FileToFormat$)
DECLARE SUB Pause (Secs!)
DECLARE SUB GetCommandParams (NumParams%, paramstring$())
DECLARE SUB GetaKey (ans$)
DECLARE SUB Center (Display$)

' --- NO, Int isn't the default!
DEFINT A-Z

WIDTH LPRINT 132

' --- This defines the maximum number of command line arguments to process
CONST MaxParams% = 8

ON ERROR GOTO HandleError

DIM paramstring$(MaxParams%)

Title$ = "  PFF(dj) 1.5" + SPACE$(27) + "Copyright 1988-91, AmSoft Development"
Footer$ = "      PFF + Programmer's File Formatter       (C) 1989-91 AmSoft Development"

CLS
COLOR 15, 13
PRINT SPACE$(80);
LOCATE 1, 1
PRINT Title$;
COLOR 11, 0

GetCommandParams NumParams%, paramstring$()

IF NumParams% = 0 THEN
	COLOR 14, 4
	Center "No File(s) Specified!"
	BEEP
	Pause 2
	END
END IF

FOR Counter = 1 TO NumParams%

Restart:
	ON ERROR GOTO HandleError
	File$ = paramstring$(Counter)
	TotalLines = 0
	Page = 0
	errorlevel = 0
	IF File$ = "" THEN
		CLS
		AllDone
	ELSE
		COLOR 14, 3
		Center "File = " + File$
		OPEN File$ FOR INPUT AS #100
		IF errorlevel = -1 THEN
			CLOSE #100
			GOTO NextFile
		END IF
		CLOSE #100
		COLOR 11, 1
		LOCATE 25, 1
		PRINT SPACE$(80);
		LOCATE 25, 1
		PRINT " Would you like to view the top of the file (Y/N)? ";
		COLOR 15
		ans$ = ""
		GetaKey ans$
		PRINT ans$;
		Pause .25
		IF UCASE$(ans$) = "Y" THEN
			COLOR 13, 0
			ViewHead File$
		END IF
		COLOR 11, 1
		LOCATE 25, 1
		PRINT SPACE$(80);
		LOCATE 25, 1
		PRINT " Print this file (Y/N)? ";
		ans$ = ""
		GetaKey ans$
		PRINT ans$;
		Pause .25
		IF UCASE$(ans$) <> "Y" THEN GOTO NextFile
		LOCATE 25, 1: PRINT SPACE$(80);
		LOCATE 25, 1
		PRINT " Do you want line numbers (Y/N)? ";
		ans$ = ""
		GetaKey ans$
		PRINT ans$;
		Pause .25
		COLOR 7, 0
		LOCATE 25, 1: PRINT SPACE$(80);
		COLOR 11, 5
		LOCATE 1, 1: PRINT SPACE$(80);
		LOCATE 1, 1: PRINT " Printing "; File$; ".    ";
		COLOR 7, 0
		FOR x = 2 TO 24
			LOCATE x, 1
			PRINT SPACE$(80);
		NEXT x
		FormatFile File$
		COLOR 13, 1
		Center "    Done    "
		Pause 3
	END IF
NextFile:

NEXT Counter
AllDone
  
HandleError:

'--- Right now we are only looking for file not found and device not ready
'--- errors.
'--- You could add all sorts of error traps here if required.
   
	errorlevel = -1
	IF ERR = 25 THEN
		COLOR 14, 4
		BEEP
		Center "Printer Not Ready!"
		Pause 2
		COLOR 7, 0
		VIEW PRINT 2 TO 24
		CLS
		VIEW PRINT
		COLOR 15, 1
		Center "Start Printer and try again."
		Pause 2
		CLOSE
		ON ERROR GOTO HandleError
		GOTO Restart
	ELSEIF ERR = 53 THEN
		COLOR 14, 4
		LOCATE 25, 1: PRINT SPACE$(80);
		LOCATE 25, 1: PRINT " File "; File$; " not found.  Continue (Y/N)? ";
		BEEP
		ans$ = ""
		GetaKey ans$
		IF ans$ <> "Y" THEN CALL AllDone
	ELSE
		COLOR 13, 1
		Center "An unknown error occurred: " + STR$(ERR)
		BEEP
		Pause 2
		END
	END IF
	RESUME NEXT
	RETURN

DEFSNG A-Z
SUB AllDone STATIC
SHARED Title$

	COLOR 7, 0: CLS
	COLOR 15, 13
	LOCATE 1, 1: PRINT SPACE$(80);
	LOCATE 1, 1
	PRINT Title$;
	COLOR 14, 1
	LOCATE 25, 1
	PRINT SPACE$(80);
	LOCATE 25, 1
	PRINT " Operation Complete!";
	BEEP
	Pause 3
	END

END SUB

SUB Center (Display$)

	xLoc = INT((80 - (4 + LEN(Display$))) / 2)
	LOCATE 7, xLoc: PRINT SPACE$(4 + LEN(Display$));
	LOCATE 8, xLoc: PRINT "  "; Display$; "  ";
	LOCATE 9, xLoc: PRINT SPACE$(4 + LEN(Display$));

END SUB

SUB FormatFile (FileToFormat$)
SHARED File$, ans$, Footer$

	ON ERROR GOTO HandleError
	DIM A$(74)
	Page = 1
	TotalLines = 0
	OPEN FileToFormat$ FOR INPUT AS #100 LEN = 2048
	plc = 1
	WHILE NOT EOF(100)
		LPRINT CHR$(27) + "E"
		LPRINT : LPRINT : LPRINT
		LPRINT "      Page -"; Page; "    "; DATE$; SPACE$(20);
		LPRINT CHR$(27); "(s3B    File: ";
		LPRINT File$ + SPACE$(20); CHR$(27); "(s0B"
		LPRINT CHR$(27) + "(s16.67H"; CHR$(27) + "(s6V";
		LPRINT CHR$(27) + CHR$(38) + CHR$(108) + "8D";
		LPRINT : LPRINT
		FOR plc = 1 TO 73
			LOCATE 2, 1: PRINT "* "
			IF EOF(100) GOTO EndOfFile
			LINE INPUT #100, A$(plc)
			j% = LEN(A$(plc))
			IF j% = 1 AND A$(plc) < " " THEN
				A$(plc) = " "
				GOTO SendFF
			END IF
			FOR count = 1 TO j%
				j$ = MID$(A$(plc), count, 1)
				IF j$ = CHR$(12) THEN
					A$ = LEFT$(A$, count - 1)
				END IF
			NEXT count
		
SendFF:

			LPRINT SPACE$(8);
			IF UCASE$(ans$) = "Y" THEN
				LPRINT USING "####"; plc + (70 * (Page - 1));
				LPRINT "  ";
			END IF
			LPRINT A$(plc)
			LOCATE 2, 1: PRINT " *"
			TotalLines = TotalLines + 1
		NEXT plc
		
EndOfFile:

		LPRINT CHR$(27) + "(s10H"; CHR$(27) + "(s12V"
		LPRINT
		IF NOT EOF(100) THEN
			LPRINT Footer$
			LPRINT CHR$(12)
			Page = Page + 1
		ELSE
			FOR count = plc TO 73
				LPRINT
			NEXT count
			LPRINT Footer$
		END IF
		WEND
		CLOSE #100
		LPRINT CHR$(12): CLOSE #200
		ERASE A$
	
END SUB

SUB GetaKey (ans$)

	ans$ = ""
	WHILE ans$ = ""
		ans$ = INKEY$
	WEND
	ans$ = UCASE$(ans$)

END SUB

SUB GetCommandParams (NumParams%, paramstring$())

comstr$ = COMMAND$
strpos% = 1
strlen% = LEN(comstr$)
NumParams% = 0

DO WHILE strpos% <= strlen%

	token$ = ""
	DO WHILE MID$(comstr$, strpos%, 1) = " " AND strpos% <= strlen%
		strpos% = strpos% + 1
	LOOP

	DO WHILE MID$(comstr$, strpos%, 1) <> " " AND strpos% <= strlen%
		token$ = token$ + MID$(comstr$, strpos%, 1)
		strpos% = strpos% + 1
	LOOP

	IF token$ <> "" AND NumParams% < MaxParams% THEN
		NumParams% = NumParams% + 1
		paramstring$(NumParams%) = token$
	END IF
   
LOOP

END SUB

SUB Pause (Secs!) STATIC

	Curr! = TIMER
	WHILE TIMER < Curr! + Secs!: WEND
  
END SUB

SUB ViewHead (VFile$) STATIC

	OPEN VFile$ FOR INPUT AS #100
	CLS
	COLOR 15, 13
	LOCATE 1, 1: PRINT SPACE$(80);
	LOCATE 1, 1
	PRINT " Viewing header of file "; VFile$
	COLOR 11, 0
	VIEW PRINT 2 TO 24
	FOR cnt% = 1 TO 21
		IF NOT EOF(100) THEN
			LINE INPUT #100, tmp$
			PRINT LEFT$(tmp$, 78)
		ELSE
			cnt% = 23
		END IF
	NEXT cnt%
	cnt% = 0
	CLOSE 100
	VIEW PRINT

END SUB

